﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using MPL;
using MELEC;

namespace MplIntSample
{
    public partial class FormMplInt : Form
    {
        public FormMplInt()
        {
            InitializeComponent();
        }

        //***********************************************************************************************************
        //
        //
        //  C#.Net Int Sample Program			5.2801.43.2309		
        //
        //
        //***********************************************************************************************************
        //Drive End Flag
        private static ushort DriveEndFlagX;
        private static ushort DriveEndFlagY;
        private static ushort DriveEndFlagZ;
        private static ushort DriveEndFlagA;
        //Device Handle				
        private static uint hDevX;
        private static uint hDevY;
        private static uint hDevZ;
        private static uint hDevA;
        //Abnormal End Flag						
        private static ushort AbnormalEndFlag;
        //Status1
        private static uint Status_X;
        private static uint Status_Y;
        private static uint Status_Z;
        private static uint Status_A;
        //Thread				
        private static Thread ThreadAdrIntDriveControl;
        private static Thread ThreadDriveControlX;
        private static Thread ThreadDriveControlY;
        private static Thread ThreadDriveControlZ;
        private static Thread ThreadDriveControlA;
        //Thread Worker
        private static AdrIntWorker AdrIntWorkerObject;
        private static XRdyIntWorker XRdyIntWorkerObject;
        private static YRdyIntWorker YRdyIntWorkerObject;
        private static ZRdyIntWorker ZRdyIntWorkerObject;
        private static ARdyIntWorker ARdyIntWorkerObject;
        //Event Handle
        private static uint hAdrEvent;
        private static uint hXRdyEvent;
        private static uint hYRdyEvent;
        private static uint hZRdyEvent;
        private static uint hARdyEvent;

        private MC07.PLPMC07CALLBACK XAdrIntCallBack = new MC07.PLPMC07CALLBACK(AdrIntCallBackX);
        private MC07.PLPMC07CALLBACK XRdyIntCallBack = new MC07.PLPMC07CALLBACK(RdyIntCallBack);
        private MC07.PLPMC07CALLBACK YRdyIntCallBack = new MC07.PLPMC07CALLBACK(RdyIntCallBack);
        private MC07.PLPMC07CALLBACK ZRdyIntCallBack = new MC07.PLPMC07CALLBACK(RdyIntCallBack);
        private MC07.PLPMC07CALLBACK ARdyIntCallBack = new MC07.PLPMC07CALLBACK(RdyIntCallBack);

        const UInt32 WAIT_ABANDONED = 0x00000080;
        const UInt32 WAIT_OBJECT_0 = 0x00000000;
        const UInt32 WAIT_TIMEOUT = 0x00000102;

        //*******************************************************************************************************************
        //
        //   Position address of motor is displayed.
        //   Parameter hDev     ･･･ Device Handle
        //             Label    ･･･ Display Label
        //
        //*******************************************************************************************************************
        void NowAddressDisplay(uint hDev, System.Windows.Forms.Control Label)
        {
            ushort Cmd;
            uint WData = 0;
            uint RData = 0;
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            Cmd = 0xD8;													// ADDRESS COUNTER READ COMMAND
            if (MC07.LWRDrive(hDev, Cmd, ref WData, ref RData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWRDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                timer1.Enabled = false;
                return;
            }
            // Position address is displayed.
            Label.Text = string.Format("{0:#,###,###,##0}", MC07.Signed32(RData));
        }
        //********************************************************************************************************************
        //
        //   Check Status1 PORT.;
        //   Parameter hDevice         ･･･ Device Handle;
        //             Axis            ･･･ Axis Data;
        //   Return Value              ･･･ TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0;
        //                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1;
        //********************************************************************************************************************
        private Boolean CheckStatus1(uint hDevice, ushort Axis)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;
            ushort Status1 = 0;
            uint WData = 0;
            uint RData = 0;
            string strAxis = "";

            if (Axis == MC07.MC07_X)
                strAxis = "(X) ";
            else if (Axis == MC07.MC07_Y)
                strAxis = "(Y) ";
            else if (Axis == MC07.MC07_Z)
                strAxis = "(Z) ";
            else if (Axis == MC07.MC07_A)
                strAxis = "(A) ";


            //*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
            if (MC07.BWaitDriveCommand(hDevice, 1000, ref sResult) == false)
            {
                label_Message.Text = strAxis + "It failed in MC07.BWaitDriveCommand() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return false;
            }

            //*** READ STATUS1 ***
            if (MC07.BRStatus1(hDevice, ref Status1, ref sResult) == false)
            {
                label_Message.Text = strAxis + "It failed in MC07.BRStatus1() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return false;
            }

            //*** CHECK STATUS1 ERROR BIT = 0 ***
            if ((Status1 & 0x0010) != 0)
            {
                //*** READ ERROR STATUS ***
                Cmd = 0xD1;
                if (MC07.LWRDrive(hDevice, Cmd, ref WData, ref RData, ref sResult) == false)
                {
                    label_Message.Text = strAxis + "It failed in MC07.LWRDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                    return false;
                }

                //GET DRIVE DATA1 PORT
                RData = RData & 0xFFFF;

                label_Message.Text = strAxis + "STATUS1 ERROR = 1 : ERROR STATUS = H'" + RData.ToString("X") + "\r\n Please click 'Clear Error'";
                return false;

            }

            return true;

        }

        //********************************************************************************************************************
        //
        //   Check Status1 PORT.;
        //   Parameter hDevice         ･･･ Device Handle;
        //   Return Value              ･･･ TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0;
        //                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1;
        //********************************************************************************************************************
        private static Boolean CheckStatus1Int(uint hDevice)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Status1 = 0;

            //*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
            if (MC07.BWaitDriveCommand(hDevice, 1000, ref sResult) == false)
            {
                return false;
            }

            //*** READ STATUS1 ***
            if (MC07.BRStatus1(hDevice, ref Status1, ref sResult) == false)
            {
                return false;
            }

            //*** CHECK STATUS1 ERROR BIT = 0 ***
            if ((Status1 & 0x0010) != 0)
            {
                return false;
            }
            return true;

        }

        //*******************************************************************************************************************
        //
        //   Setting the condition of the button in not drive condition.
        //
        //*******************************************************************************************************************
        private void ButtonEnable()
        {
            button_CallBack.Enabled = true;
            button_Event.Enabled = true;
            button_SlowStop.Enabled = true;
            button_FastStop.Enabled = true;
            button_Open.Enabled = false;
            button_Close.Enabled = true;
            button_ClearError.Enabled = true;
            button_End.Enabled = false;

        }

        //*******************************************************************************************************************
        //
        //   Setting the condition of the button in drive condition.
        //
        //*******************************************************************************************************************
        private void ButtonDisable()
        {
            button_CallBack.Enabled = false;
            button_Event.Enabled = false;
            button_SlowStop.Enabled = true;
            button_FastStop.Enabled = true;
            button_Open.Enabled = false;
            button_Close.Enabled = false;
            button_ClearError.Enabled = false;
            button_End.Enabled = false;
        }

        //********************************************************************************************************************
        //
        //   The processing that FormMplInt is loaded;
        //
        //********************************************************************************************************************
        private void FormMplInt_Load(object sender, EventArgs e)
        {
            button_CallBack.Enabled = false;
            button_Event.Enabled = false;
            button_SlowStop.Enabled = false;
            button_FastStop.Enabled = false;
            button_Open.Enabled = true;
            button_Close.Enabled = false;
            button_ClearError.Enabled = false;
            button_End.Enabled = true;

        }

        //*******************************************************************************************************************
        //
        //   The processing that Function Error has happened.
        //
        //*******************************************************************************************************************
        private void ErrorOperation()
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);

            bool RetX, RetY, RetZ, RetA = false;

            //***  All Axes : Close Device Int ***
            RetX = MC07.CloseDevInt(hDevX, ref sResultX);
            RetY = MC07.CloseDevInt(hDevY, ref sResultY);
            RetZ = MC07.CloseDevInt(hDevZ, ref sResultZ);
            RetA = MC07.CloseDevInt(hDevA, ref sResultA);

            //***  All Axes : Clear Device Int ***
            RetX = MC07.ClearIntSet(hDevX, ref sResultX);
            RetY = MC07.ClearIntSet(hDevY, ref sResultY);
            RetZ = MC07.ClearIntSet(hDevZ, ref sResultA);
            RetA = MC07.ClearIntSet(hDevA, ref sResultA);
        }
        //********************************************************************************************************************
        //
        //   The processing that timer1;
        //
        //********************************************************************************************************************
        private void timer1_Tick_1(object sender, EventArgs e)
        {
            NowAddressDisplay(hDevX, label_MessageX);
            NowAddressDisplay(hDevY, label_MessageY);
            NowAddressDisplay(hDevZ, label_MessageZ);
            NowAddressDisplay(hDevA, label_MessageA);

        }

        //********************************************************************************************************************
        //
        //   The processing that the Open button was clicked.;
        //
        //********************************************************************************************************************
        private void button_Open_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);

            bool RetX, RetY, RetZ, RetA = false;

            label_Message.Text = "";

            //*** DEVICE OPEN ***
            RetX = MC07.BOpen(0, MC07.MC07_X, ref hDevX, ref sResultX);
            RetY = MC07.BOpen(0, MC07.MC07_Y, ref hDevY, ref sResultY);
            RetZ = MC07.BOpen(0, MC07.MC07_Z, ref hDevZ, ref sResultZ);
            RetA = MC07.BOpen(0, MC07.MC07_A, ref hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BOpen()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();

                RetX = MC07.BClose(hDevX, ref sResultX);
                RetY = MC07.BClose(hDevY, ref sResultY);
                RetZ = MC07.BClose(hDevZ, ref sResultZ);
                RetA = MC07.BClose(hDevA, ref sResultA);

                return;
            }

            timer1.Enabled = true;

            ButtonEnable();


        }

        //********************************************************************************************************************
        //
        //   The processing that the Close button was clicked.;
        //
        //********************************************************************************************************************
        private void button_Close_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);

            bool RetX, RetY, RetZ, RetA = false;

            timer1.Enabled = false;

            //*** DEVICE CLOSE ***
            RetX = MC07.BClose(hDevX, ref sResultX);
            RetY = MC07.BClose(hDevY, ref sResultY);
            RetZ = MC07.BClose(hDevZ, ref sResultZ);
            RetA = MC07.BClose(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BClose()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                return;
            }

            label_MessageX.Text = "";
            label_MessageY.Text = "";
            label_MessageZ.Text = "";
            label_MessageA.Text = "";
            label_Message.Text = "";

            button_CallBack.Enabled = false;
            button_Event.Enabled = false;
            button_SlowStop.Enabled = false;
            button_FastStop.Enabled = false;
            button_Open.Enabled = true;
            button_Close.Enabled = false;
            button_ClearError.Enabled = false;
            button_End.Enabled = true;

        }

        //********************************************************************************************************************
        //
        //   The processing that the Clear Error button was clicked.;
        //
        //********************************************************************************************************************
        private void button_ClearError_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);
            bool RetX;
            bool RetY;
            bool RetZ;
            bool RetA;


            //*** CLEAR ERROR ***
            RetX = MC07.ClrError(hDevX, ref sResultX);
            RetY = MC07.ClrError(hDevY, ref sResultY);
            RetZ = MC07.ClrError(hDevZ, ref sResultZ);
            RetA = MC07.ClrError(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.ClrError()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                return;
            }

            label_Message.Text = "MC07_ClrError() succeed";

        }

        private void button_End_Click(object sender, EventArgs e)
        {
            Application.Exit();

        }

        //********************************************************************************************************************
        //
        //   The processing that the Slow Stop button was clicked.;
        //
        //********************************************************************************************************************
        private void button_SlowStop_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);
            ushort Cmd;
            bool RetX;
            bool RetY;
            bool RetZ;
            bool RetA;


            //*** SLOW STOP ***
            Cmd = 0xFE;
            RetX = MC07.BWDriveCommand(hDevX, ref Cmd, ref sResultX);
            RetY = MC07.BWDriveCommand(hDevY, ref Cmd, ref sResultY);
            RetZ = MC07.BWDriveCommand(hDevZ, ref Cmd, ref sResultZ);
            RetA = MC07.BWDriveCommand(hDevA, ref Cmd, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BWDriveCommand(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

        }

        //********************************************************************************************************************
        //
        //   The processing that the Fast Stop button was clicked.;
        //
        //********************************************************************************************************************
        private void button_FastStop_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);
            ushort Cmd;
            bool RetX;
            bool RetY;
            bool RetZ;
            bool RetA;


            //*** FAST STOP ***
            Cmd = 0xFF;
            RetX = MC07.BWDriveCommand(hDevX, ref Cmd, ref sResultX);
            RetY = MC07.BWDriveCommand(hDevY, ref Cmd, ref sResultY);
            RetZ = MC07.BWDriveCommand(hDevZ, ref Cmd, ref sResultZ);
            RetA = MC07.BWDriveCommand(hDevA, ref Cmd, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BWDriveCommand(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }


        }

        //*******************************************************************************************************************
        //
        //
        //	CallBack Sample
        //
        //
        //*******************************************************************************************************************


        //********************************************************************************************************************
        //
        //   The processing that the CallBack button was clicked.;
        //
        //********************************************************************************************************************
        private void button_CallBack_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);
            ushort Cmd;
            ushort Status1X = 0;
            ushort Status1Y = 0;
            ushort Status1Z = 0;
            ushort Status1A = 0;
            uint LData;
            bool RetX;
            bool RetY;
            bool RetZ;
            bool RetA;

            label_MessageX.Text = "";
            label_MessageY.Text = "";
            label_MessageZ.Text = "";
            label_MessageA.Text = "";
            label_Message.Text = "";

            DriveEndFlagX = 1;
            DriveEndFlagY = 1;
            DriveEndFlagZ = 1;
            DriveEndFlagA = 1;

            // AbnormalEndFlg = OFF
            AbnormalEndFlag = 0;

            //*** All Axes : STATUS1 READ ***
            RetX = MC07.BRStatus1(hDevX, ref Status1X, ref sResultX);
            RetY = MC07.BRStatus1(hDevY, ref Status1Y, ref sResultY);
            RetZ = MC07.BRStatus1(hDevZ, ref Status1Z, ref sResultZ);
            RetA = MC07.BRStatus1(hDevA, ref Status1A, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BRStatus1()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                return;
            }

            Status_X = (uint)Status1X;
            Status_Y = (uint)Status1Y;
            Status_Z = (uint)Status1Z;
            Status_A = (uint)Status1A;

            label_Message.Text = "CallBack Int Demonstration Start";
            ButtonDisable();

            //*** All Axes : ADDRESS COUNTER PRESET = 0 ***
            Cmd = 0x80;
            LData = 0;
            RetX = MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX);
            RetY = MC07.LWDrive(hDevY, Cmd, ref LData, ref sResultY);
            RetZ = MC07.LWDrive(hDevZ, Cmd, ref LData, ref sResultZ);
            RetA = MC07.LWDrive(hDevA, Cmd, ref LData, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }


            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER1 = 10000 ***
            Cmd = 0x88;
            LData = 10000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER2 = 20000 ***
            Cmd = 0x89;
            LData = 20000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER3 = 30000 ***
            Cmd = 0x8A;
            LData = 30000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER INITIALIZE1 COMMAND ***
            //*** D8 :ADRINT TYPE0 = 1
            //*** D9 :ADRINT TYPE1 = 1
            Cmd = 0x81;
            LData = 0x0330;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER INITIALIZE2 COMMAND ***
            //*** D0 :COMP1 INT ENABLE = 1
            //*** D4 :COMP2 INT ENABLE = 1
            //*** D8 :COMP3 INT ENABLE = 1
            Cmd = 0x82;
            LData = 0x0111;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** All Axes : SPEC INITIALIZE2 COMMAND ***
            //*** D4 :RDYINT TYPE0 = 0
            //*** D5 :RDYINT TYPE1 = 0
            Cmd = 0x02;
            LData = 0x0F00;
            if (CheckStatus1(hDevX, MC07.MC07_X) == false)
            {
                ButtonEnable();
                return;
            }
            RetX = MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX);

            if (CheckStatus1(hDevY, MC07.MC07_Y) == false)
            {
                ButtonEnable();
                return;
            }
            RetY = MC07.LWDrive(hDevY, Cmd, ref LData, ref sResultY);

            if (CheckStatus1(hDevZ, MC07.MC07_Z) == false)
            {
                ButtonEnable();
                return;
            }
            RetZ = MC07.LWDrive(hDevZ, Cmd, ref LData, ref sResultZ);

            if (CheckStatus1(hDevA, MC07.MC07_A) == false)
            {
                ButtonEnable();
                return;
            }
            RetA = MC07.LWDrive(hDevA, Cmd, ref LData, ref sResultA);

            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : Set IntCallBack( ADRINT CallBack ) ***
            if (MC07.SetIntCallBack(hDevX, MC07.MC07_INT_FACTOR_ADRINT, XAdrIntCallBack, 0, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.SetIntCallBack(): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** All Axes : SetIntCallBack (RDYINT)   ***
            RetX = MC07.SetIntCallBack(hDevX, MC07.MC07_INT_FACTOR_RDYINT, XRdyIntCallBack, MC07.MC07_X, ref sResultX);
            RetY = MC07.SetIntCallBack(hDevY, MC07.MC07_INT_FACTOR_RDYINT, YRdyIntCallBack, MC07.MC07_Y, ref sResultY);
            RetZ = MC07.SetIntCallBack(hDevZ, MC07.MC07_INT_FACTOR_RDYINT, ZRdyIntCallBack, MC07.MC07_Z, ref sResultZ);
            RetA = MC07.SetIntCallBack(hDevA, MC07.MC07_INT_FACTOR_RDYINT, ARdyIntCallBack, MC07.MC07_A, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.SetIntCallBack()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //*** All Axes : Open DevInt   ***
            RetX = MC07.OpenDevInt(hDevX, ref sResultX);
            RetY = MC07.OpenDevInt(hDevY, ref sResultY);
            RetZ = MC07.OpenDevInt(hDevZ, ref sResultZ);
            RetA = MC07.OpenDevInt(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.OpenDevInt()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //*** X Axis : ABSOLUTE INDEX DRIVE COMMAND (50000)***
            Cmd = 0x15;
            LData = 50000;
            if (CheckStatus1(hDevX, MC07.MC07_X) == false)
            {
                ErrorOperation();
                ButtonEnable();
                return;
            }
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }
            // X Axis : DriveEndFlg = OFF
            DriveEndFlagX = 0;

            //*** All Axes : Wait CallBack Demonstration Drive End ***
            do
            {
                Application.DoEvents();
            } while (((DriveEndFlagX != 0) & (DriveEndFlagY != 0) & (DriveEndFlagZ != 0) & (DriveEndFlagA != 0)) == false);

            // Display Drive End Status
            if (AbnormalEndFlag == 1)
            {
                label_Message.Text = "Abnormanl End \r\n: X : Status1 = H'" + Status_X.ToString("X") +
                    "\r\n: Y : Status1 = H'" + Status_Y.ToString("X") +
                    "\r\n: Z : Status1 = H'" + Status_Z.ToString("X") +
                    "\r\n: A : Status1 = H'" + Status_A.ToString("X");
            }
            else
            {
                label_Message.Text = "CallBack Int Demonstration End";
            }

            //***  All Axes : Close Device Int ***
            RetX = MC07.CloseDevInt(hDevX, ref sResultX);
            RetY = MC07.CloseDevInt(hDevY, ref sResultY);
            RetZ = MC07.CloseDevInt(hDevZ, ref sResultZ);
            RetA = MC07.CloseDevInt(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.CloseDevInt()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //***  All Axes : Clear Device Int ***
            RetX = MC07.ClearIntSet(hDevX, ref sResultX);
            RetY = MC07.ClearIntSet(hDevY, ref sResultY);
            RetZ = MC07.ClearIntSet(hDevZ, ref sResultA);
            RetA = MC07.ClearIntSet(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.ClearIntSet()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            ButtonEnable();
        }

        //*******************************************************************************************************************
        //
        //	X Axis : ADRINT CallBack 
        //
        //*******************************************************************************************************************
        static void AdrIntCallBackX(int Status, int Dummy)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd;
            uint LData;

            //*** ADDRESS COUNTER COMPARE REGISTER1 ---> Y Axis : ABSOLUTE INDEX DRIVE(10000) ***
            if ((Status & 0x0001) != 0)
            {
                Cmd = 0x15;
                LData = 10000;
                if (CheckStatus1Int(hDevY) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                if (MC07.LWDrive(hDevY, Cmd, ref LData, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                // Y Axis : DriveEndFlg = OFF
                DriveEndFlagY = 0;
            }
            //*** ADDRESS COUNTER COMPARE REGISTER2 ---> Z Axis : ABSOLUTE INDEX DRIVE(10000) ***
            else if ((Status & 0x0002) != 0)
            {
                Cmd = 0x15;
                LData = 10000;
                if (CheckStatus1Int(hDevZ) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                if (MC07.LWDrive(hDevZ, Cmd, ref LData, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                // Z Axis : DriveEndFlg = OFF
                DriveEndFlagZ = 0;
            }
            //*** ADDRESS COUNTER COMPARE REGISTER3 ---> A Axis : ABSOLUTE INDEX DRIVE(10000) ***
            else if ((Status & 0x0004) != 0)
            {
                Cmd = 0x15;
                LData = 10000;
                if (CheckStatus1Int(hDevA) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                if (MC07.LWDrive(hDevA, Cmd, ref LData, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    return;
                }
                // A Axis : DriveEndFlg = OFF
                DriveEndFlagA = 0;
            }
        }

        //*******************************************************************************************************************
        //
        //	All Axes RDYINT CallBack 
        //
        //*******************************************************************************************************************
        static void RdyIntCallBack(int Status, int Axis)
        {
            // Check Abnormal End
            if ((Status & 0x00F0) != 0)
                AbnormalEndFlag = 1;

            if (Axis == MC07.MC07_X)
            {
                Status_X = (uint)Status;
                DriveEndFlagX = 1;
            }
            else if (Axis == MC07.MC07_Y)
            {
                Status_Y = (uint)Status;
                DriveEndFlagY = 1;
            }
            else if (Axis == MC07.MC07_Z)
            {
                Status_Z = (uint)Status;
                DriveEndFlagZ = 1;
            }
            else if (Axis == MC07.MC07_A)
            {
                Status_A = (uint)Status;
                DriveEndFlagA = 1;
            }
        }

        //*******************************************************************************************************************
        //
        //
        //	Event Sample
        //
        //
        //*******************************************************************************************************************



        //********************************************************************************************************************
        //
        //   The processing that the Event button was clicked.;
        //
        //********************************************************************************************************************
        private void button_Event_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResultX = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultY = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultZ = new MC07_S_RESULT(0);
            MC07_S_RESULT sResultA = new MC07_S_RESULT(0);
            ushort Cmd;
            ushort Status1X = 0;
            ushort Status1Y = 0;
            ushort Status1Z = 0;
            ushort Status1A = 0;
            uint LData;
            bool RetX;
            bool RetY;
            bool RetZ;
            bool RetA;

            label_MessageX.Text = "";
            label_MessageY.Text = "";
            label_MessageZ.Text = "";
            label_MessageA.Text = "";
            label_Message.Text = "";
            Application.DoEvents();

            DriveEndFlagX = 1;
            DriveEndFlagY = 1;
            DriveEndFlagZ = 1;
            DriveEndFlagA = 1;

            // AbnormalEndFlg = OFF
            AbnormalEndFlag = 0;

            //*** All Axes : STATUS1 READ ***
            RetX = MC07.BRStatus1(hDevX, ref Status1X, ref sResultX);
            RetY = MC07.BRStatus1(hDevY, ref Status1Y, ref sResultY);
            RetZ = MC07.BRStatus1(hDevZ, ref Status1Z, ref sResultZ);
            RetA = MC07.BRStatus1(hDevA, ref Status1A, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.BRStatus1()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                return;
            }

            Status_X = (uint)Status1X;
            Status_Y = (uint)Status1Y;
            Status_Z = (uint)Status1Z;
            Status_A = (uint)Status1A;

            label_Message.Text = "Event Int Demonstration Start";
            ButtonDisable();

            //*** All Axes : ADDRESS COUNTER PRESET = 0 ***
            Cmd = 0x80;
            LData = 0;
            RetX = MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX);
            RetY = MC07.LWDrive(hDevY, Cmd, ref LData, ref sResultY);
            RetZ = MC07.LWDrive(hDevZ, Cmd, ref LData, ref sResultZ);
            RetA = MC07.LWDrive(hDevA, Cmd, ref LData, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }


            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER1 = 10000 ***
            Cmd = 0x88;
            LData = 10000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER2 = 20000 ***
            Cmd = 0x89;
            LData = 20000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER COMPARE REGISTER3 = 30000 ***
            Cmd = 0x8A;
            LData = 30000;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER INITIALIZE1 COMMAND ***
            //*** D8 :ADRINT TYPE0 = 1
            //*** D9 :ADRINT TYPE1 = 1
            Cmd = 0x81;
            LData = 0x0330;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** X Axis : ADDRESS COUNTER INITIALIZE2 COMMAND ***
            //*** D0 :COMP1 INT ENABLE = 1
            //*** D4 :COMP2 INT ENABLE = 1
            //*** D8 :COMP3 INT ENABLE = 1
            Cmd = 0x82;
            LData = 0x0111;
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {

                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** All Axes : SPEC INITIALIZE2 COMMAND ***
            //*** D4 :RDYINT TYPE0 = 0
            //*** D5 :RDYINT TYPE1 = 0
            Cmd = 0x02;
            LData = 0x0F00;
            if (CheckStatus1(hDevX, MC07.MC07_X) == false)
            {
                ButtonEnable();
                return;
            }
            RetX = MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX);

            if (CheckStatus1(hDevY, MC07.MC07_Y) == false)
            {
                ButtonEnable();
                return;
            }
            RetY = MC07.LWDrive(hDevY, Cmd, ref LData, ref sResultY);

            if (CheckStatus1(hDevZ, MC07.MC07_Z) == false)
            {
                ButtonEnable();
                return;
            }
            RetZ = MC07.LWDrive(hDevZ, Cmd, ref LData, ref sResultZ);

            if (CheckStatus1(hDevA, MC07.MC07_A) == false)
            {
                ButtonEnable();
                return;
            }
            RetA = MC07.LWDrive(hDevA, Cmd, ref LData, ref sResultA);

            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ")\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** CreateEvent ***
            hAdrEvent = WIN32.CreateEvent(0, false, false, null);

            //*** SetIntEvent (ADRINT)   ***
            if (MC07.SetIntEvent(hDevX, MC07.MC07_INT_FACTOR_ADRINT, hAdrEvent, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.SetIntEvent(): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ButtonEnable();
                return;
            }

            //*** CreateEvent ***
            hXRdyEvent = WIN32.CreateEvent(0, false, false, null);
            hYRdyEvent = WIN32.CreateEvent(0, false, false, null);
            hZRdyEvent = WIN32.CreateEvent(0, false, false, null);
            hARdyEvent = WIN32.CreateEvent(0, false, false, null);

            //*** All Axes : SetIntEvent (RDYINT)   ***
            RetX = MC07.SetIntEvent(hDevX, MC07.MC07_INT_FACTOR_RDYINT, hXRdyEvent, ref sResultX);
            RetY = MC07.SetIntEvent(hDevY, MC07.MC07_INT_FACTOR_RDYINT, hYRdyEvent, ref sResultY);
            RetZ = MC07.SetIntEvent(hDevZ, MC07.MC07_INT_FACTOR_RDYINT, hZRdyEvent, ref sResultZ);
            RetA = MC07.SetIntEvent(hDevA, MC07.MC07_INT_FACTOR_RDYINT, hARdyEvent, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.SetIntEvent()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //*** All Axes : Open DevInt   ***
            RetX = MC07.OpenDevInt(hDevX, ref sResultX);
            RetY = MC07.OpenDevInt(hDevY, ref sResultY);
            RetZ = MC07.OpenDevInt(hDevZ, ref sResultZ);
            RetA = MC07.OpenDevInt(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.OpenDevInt()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //*** X Axis : ABSOLUTE INDEX DRIVE (50000) ***
            Cmd = 0x15;
            LData = 50000;
            if (CheckStatus1(hDevX, MC07.MC07_X) == false)
            {
                ErrorOperation();
                ButtonEnable();
                return;
            }
            if (MC07.LWDrive(hDevX, Cmd, ref LData, ref sResultX) == false)
            {
                label_Message.Text = "(X)It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + "): MC07_Result(1)=" + sResultX.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }
            DriveEndFlagX = 0;

            //*** All Axes : Creat Controll Drive Thread ***
            AdrIntWorkerObject = new AdrIntWorker();
            XRdyIntWorkerObject = new XRdyIntWorker();
            YRdyIntWorkerObject = new YRdyIntWorker();
            ZRdyIntWorkerObject = new ZRdyIntWorker();
            ARdyIntWorkerObject = new ARdyIntWorker();

            ThreadStart AdrThread = new ThreadStart(AdrIntWorkerObject.DoWork);
            ThreadStart XThread = new ThreadStart(XRdyIntWorkerObject.DoWork);
            ThreadStart YThread = new ThreadStart(YRdyIntWorkerObject.DoWork);
            ThreadStart ZThread = new ThreadStart(ZRdyIntWorkerObject.DoWork);
            ThreadStart AThread = new ThreadStart(ARdyIntWorkerObject.DoWork);

            ThreadAdrIntDriveControl = new Thread(AdrThread);
            ThreadDriveControlX = new Thread(XThread);
            ThreadDriveControlY = new Thread(YThread);
            ThreadDriveControlZ = new Thread(ZThread);
            ThreadDriveControlA = new Thread(AThread);

            ThreadAdrIntDriveControl.IsBackground = true;
            ThreadDriveControlX.IsBackground = true;
            ThreadDriveControlY.IsBackground = true;
            ThreadDriveControlZ.IsBackground = true;
            ThreadDriveControlA.IsBackground = true;

            ThreadAdrIntDriveControl.Start();
            ThreadDriveControlX.Start();
            ThreadDriveControlY.Start();
            ThreadDriveControlZ.Start();
            ThreadDriveControlA.Start();

            //*** All Axes : Wait Event Int Demonstration End ***
            do
            {
                Application.DoEvents();
            } while (((DriveEndFlagX != 0) & (DriveEndFlagY != 0) & (DriveEndFlagZ != 0) & (DriveEndFlagA != 0)) == false);

            Application.DoEvents();

            // Display Drive End Status
            if (AbnormalEndFlag == 1)
            {
                label_Message.Text = "Abnormanl End \r\n: X : Status1 = H'" + Status_X.ToString("X") +
                    "\r\n: Y : Status1 = H'" + Status_Y.ToString("X") +
                    "\r\n: Z : Status1 = H'" + Status_Z.ToString("X") +
                    "\r\n: A : Status1 = H'" + Status_A.ToString("X");
            }
            else
            {
                label_Message.Text = "Event Int Demonstration End";
            }

            //*** Close Event ***
            WIN32.CloseHandle(hAdrEvent);
            WIN32.CloseHandle(hXRdyEvent);
            WIN32.CloseHandle(hYRdyEvent);
            WIN32.CloseHandle(hZRdyEvent);
            WIN32.CloseHandle(hARdyEvent);

            //***  All Axes : Close Device Int ***
            RetX = MC07.CloseDevInt(hDevX, ref sResultX);
            RetY = MC07.CloseDevInt(hDevY, ref sResultY);
            RetZ = MC07.CloseDevInt(hDevZ, ref sResultZ);
            RetA = MC07.CloseDevInt(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.CloseDevInt()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            //***  All Axes : Clear Device Int ***
            RetX = MC07.ClearIntSet(hDevX, ref sResultX);
            RetY = MC07.ClearIntSet(hDevY, ref sResultY);
            RetZ = MC07.ClearIntSet(hDevZ, ref sResultA);
            RetA = MC07.ClearIntSet(hDevA, ref sResultA);
            if ((RetX == false) | (RetY == false) | (RetZ == false) | (RetA == false))
            {
                label_Message.Text = "It failed in MC07.ClearIntSet()\r\n: X : MC07_Result(1)=" + sResultX.MC07_Result[1].ToString() +
                    "\r\n: Y : MC07_Result(1)=" + sResultY.MC07_Result[1].ToString() +
                    "\r\n: Z : MC07_Result(1)=" + sResultZ.MC07_Result[1].ToString() +
                    "\r\n: A : MC07_Result(1)=" + sResultA.MC07_Result[1].ToString();
                ErrorOperation();
                ButtonEnable();
                return;
            }

            ButtonEnable();

        }


        //*******************************************************************************************************************
        //
        //	Y-Z-A Axes Control : ADRINT THREAD
        //
        //*******************************************************************************************************************
        public class AdrIntWorker
        {
            // This method will be called when the thread is started.
            public void DoWork()
            {

                MC07_S_RESULT sResult = new MC07_S_RESULT(0);
                ushort Cmd;
                uint Status = 0;
                uint LData;
                uint hDevice = 0;
                ushort i;

                for (i = 0; i < 3; i++)
                {

                    while (!_shouldStop)
                    {
                        //*** Wait X Axis : XADRINT EVENT ***
                        if (WIN32.WaitForSingleObject(hAdrEvent, 10) == WAIT_OBJECT_0) break;
                    }

                    // Check Thread End Flag
                    if (_shouldStop == true) return;

                    if (MC07.ReadIntStatus(hDevX, MC07.MC07_INT_FACTOR_ADRINT, ref Status, ref sResult) == false)
                    {
                        AbnormalEndFlag = 1;
                        return;
                    }

                    //*** ADDRESS COUNTER COMPARE REGISTER1 ---> Y Axis : ABSOLUTE INDEX DRIVE(10000) ***
                    if ((Status & 0x0001) != 0)
                        hDevice = hDevY;
                    //*** ADDRESS COUNTER COMPARE REGISTER2 ---> Z Axis : ABSOLUTE INDEX DRIVE(10000) ***
                    else if ((Status & 0x0002) != 0)
                        hDevice = hDevZ;
                    //*** ADDRESS COUNTER COMPARE REGISTER3 ---> A Axis : ABSOLUTE INDEX DRIVE(10000) ***
                    else if ((Status & 0x0004) != 0)
                        hDevice = hDevA;

                    //*** ABSOLUTE INDEX DRIVE ***
                    Cmd = 0x15;
                    LData = 10000;
                    if (CheckStatus1Int(hDevice) == false)
                    {
                        AbnormalEndFlag = 1;
                        return;
                    }


                    if (MC07.LWDrive(hDevice, Cmd, ref LData, ref sResult) == false)
                    {
                        AbnormalEndFlag = 1;
                        return;
                    }


                    if ((Status & 0x0001) != 0)
                        DriveEndFlagY = 0;
                    else if ((Status & 0x0002) != 0)
                        DriveEndFlagZ = 0;
                    else if ((Status & 0x0004) != 0)
                        DriveEndFlagA = 0;

                }

            }
            public void RequestStop()
            {
                _shouldStop = true;
            }
            private volatile bool _shouldStop;
        }


        //*******************************************************************************************************************
        //
        //	X Axis : RDYINT THREAD
        //
        //*******************************************************************************************************************
        public class XRdyIntWorker
        {
            // This method will be called when the thread is started.
            public void DoWork()
            {

                MC07_S_RESULT sResult = new MC07_S_RESULT(0);
                uint Status = 0;

                while (!_shouldStop)
                {
                    //*** Wait X Axis : XADRINT EVENT ***
                    if (WIN32.WaitForSingleObject(hXRdyEvent, 10) == WAIT_OBJECT_0) break;
                }

                // Check Thread End Flag
                if (_shouldStop == true) return;

                if (MC07.ReadIntStatus(hDevX, MC07.MC07_INT_FACTOR_RDYINT, ref Status, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    DriveEndFlagX = 1;
                    return;
                }


                //*** Check Drive End Status ***
                if ((Status & 0x00F0) != 0)
                {
                    // Because Stop ADRINT Thead
                    AdrIntWorkerObject.RequestStop(); ThreadAdrIntDriveControl.Join();

                    // Because Stop RDYINT Thread
                    if (DriveEndFlagY == 1)
                        YRdyIntWorkerObject.RequestStop(); ThreadDriveControlY.Join();
                    if (DriveEndFlagZ == 1)
                        ZRdyIntWorkerObject.RequestStop(); ThreadDriveControlZ.Join();
                    if (DriveEndFlagA == 1)
                        ARdyIntWorkerObject.RequestStop(); ThreadDriveControlA.Join();

                    AbnormalEndFlag = 1;

                }

                Status_X = Status;
                DriveEndFlagX = 1;


            }
            public void RequestStop()
            {
                _shouldStop = true;
            }
            private volatile bool _shouldStop;
        }

        //*******************************************************************************************************************
        //
        //	Y Axis : RDYINT THREAD
        //
        //*******************************************************************************************************************
        public class YRdyIntWorker
        {
            // This method will be called when the thread is started.
            public void DoWork()
            {

                MC07_S_RESULT sResult = new MC07_S_RESULT(0);
                uint Status = 0;

                while (!_shouldStop)
                {
                    //*** Wait Y Axis : YRDYINT EVENT ***
                    if (WIN32.WaitForSingleObject(hYRdyEvent, 10) == WAIT_OBJECT_0) break;
                }

                // Check Thread End Flag
                if (_shouldStop == true) return;

                if (MC07.ReadIntStatus(hDevY, MC07.MC07_INT_FACTOR_RDYINT, ref Status, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    DriveEndFlagY = 1;
                    return;
                }


                // Check Abnormal End
                if ((Status & 0x00F0) != 0)
                    AbnormalEndFlag = 1;

                Status_Y = Status;
                DriveEndFlagY = 1;

            }
            public void RequestStop()
            {
                _shouldStop = true;
            }
            private volatile bool _shouldStop;

        }

        //*******************************************************************************************************************
        //
        //	Z Axis : RDYINT THREAD
        //
        //*******************************************************************************************************************
        public class ZRdyIntWorker
        {
            // This method will be called when the thread is started.
            public void DoWork()
            {

                MC07_S_RESULT sResult = new MC07_S_RESULT(0);
                uint Status = 0;

                while (!_shouldStop)
                {
                    //*** Wait Z Axis : ZRDYINT EVENT ***
                    if (WIN32.WaitForSingleObject(hZRdyEvent, 10) == WAIT_OBJECT_0) break;
                }

                // Check Thread End Flag
                if (_shouldStop == true) return;

                if (MC07.ReadIntStatus(hDevZ, MC07.MC07_INT_FACTOR_RDYINT, ref Status, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    DriveEndFlagZ = 1;
                    return;
                }


                // Check Abnormal End
                if ((Status & 0x00F0) != 0)
                    AbnormalEndFlag = 1;

                Status_Z = Status;
                DriveEndFlagZ = 1;

            }
            public void RequestStop()
            {
                _shouldStop = true;
            }
            private volatile bool _shouldStop;

        }

        //*******************************************************************************************************************
        //
        //	A Axis : RDYINT THREAD
        //
        //*******************************************************************************************************************
        public class ARdyIntWorker
        {
            // This method will be called when the thread is started.
            public void DoWork()
            {

                MC07_S_RESULT sResult = new MC07_S_RESULT(0);
                uint Status = 0;

                while (!_shouldStop)
                {
                    //*** Wait A Axis : ARDYINT EVENT ***
                    if (WIN32.WaitForSingleObject(hARdyEvent, 10) == WAIT_OBJECT_0) break;
                }

                // Check Thread End Flag
                if (_shouldStop == true) return;

                if (MC07.ReadIntStatus(hDevA, MC07.MC07_INT_FACTOR_RDYINT, ref Status, ref sResult) == false)
                {
                    AbnormalEndFlag = 1;
                    DriveEndFlagA = 1;
                    return;
                }


                // Check Abnormal End
                if ((Status & 0x00F0) != 0)
                    AbnormalEndFlag = 1;

                Status_A = Status;
                DriveEndFlagA = 1;

            }
            public void RequestStop()
            {
                _shouldStop = true;
            }
            private volatile bool _shouldStop;

        }



    }
}