﻿Public Class Form1
    '****************************************************************************************************************
    '
    '
    '   VB.NET Int Sample Program			5.2801.42.2309	
    '
    '
    '****************************************************************************************************************
    'Drive End Flag
    Private DriveEndFlagX As Short
    Private DriveEndFlagY As Short
    Private DriveEndFlagZ As Short
    Private DriveEndFlagA As Short
    'Device Handle
    Private hDevX As Integer
    Private hDevY As Integer
    Private hDevZ As Integer
    Private hDevA As Integer
    'Abnormal End Flag
    Private AbnormalEndFlag As Short
    'Status1
    Private Status1X As Integer
    Private Status1Y As Integer
    Private Status1Z As Integer
    Private Status1A As Integer

    'EVENT HANDLE
    Dim hAdrEvent As Integer
    Dim hXRdyEvent As Integer
    Dim hYRdyEvent As Integer
    Dim hZRdyEvent As Integer
    Dim hARdyEvent As Integer

    'THREAD
    Dim AdrThread As System.Threading.Thread
    Dim XThread As System.Threading.Thread
    Dim YThread As System.Threading.Thread
    Dim ZThread As System.Threading.Thread
    Dim AThread As System.Threading.Thread

    'THREAD END FLAG
    Dim AdrThreadEndFlag As Short
    Dim XThreadEndFlag As Short
    Dim YThreadEndFlag As Short
    Dim ZThreadEndFlag As Short
    Dim AThreadEndFlag As Short

    Dim XAdrIntCallBack As New PLPMC07CALLBACK(AddressOf AdrIntCallBackX)
    Dim XRdyIntCallBack As New PLPMC07CALLBACK(AddressOf RdyIntCallBack)
    Dim YRdyIntCallBack As New PLPMC07CALLBACK(AddressOf RdyIntCallBack)
    Dim ZRdyIntCallBack As New PLPMC07CALLBACK(AddressOf RdyIntCallBack)
    Dim ARdyIntCallBack As New PLPMC07CALLBACK(AddressOf RdyIntCallBack)

    Private Const WAIT_OBJECT_0 As Integer = 0

    '********************************************************************************************************************
    '
    '   Display Address Counter.
    '   Parameter hDev            ･･･ Device Handle
    '             LabelNowAddr    ･･･ Display Label
    '********************************************************************************************************************
    Private Sub NowAddressDisplay(ByVal hDev As Integer, ByRef LabelNowAddr As Label)
        Dim Cmd As Short
        Dim sResult As New MC07_S_RESULT()
        Dim WData As Integer
        Dim RData As Integer

        sResult.Initialize()

        Cmd = &HD8S
        WData = 0
        If (False = MC07_LWRDrive(hDev, Cmd, WData, RData, sResult)) Then                  'ADDRESS COUNTER READ COMMAND
            Label_Message.Text = "It failed in MC07_LWRDrive(H'" & Hex(Cmd) & ") : MC07_Result(1)=" & Str(sResult.MC07_Result(1))
            Timer1.Enabled = False
            Exit Sub

        End If
        LabelNowAddr.Text = CStr(MC07_Unsigned32(RData))
    End Sub

    '********************************************************************************************************************
    '
    '   Check Status1 PORT.
    '   Parameter hDevice         ･･･ Device Handle
    '             Axis            ･･･ Axis Data
    '   Return Value              ･･･ TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0
    '                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1
    '********************************************************************************************************************
    Private Function CheckStatus1(ByVal hDevice As Integer, ByVal Axis As Short) As Boolean
        Dim sResult As New MC07_S_RESULT()
        Dim Status1 As Short
        Dim WData As Integer
        Dim RData As Integer
        Dim Cmd As Short
        Dim StrMsg As String = ""

        sResult.Initialize()

        CheckStatus1 = False

        Select Case Axis
            Case MC07_X
                StrMsg = "(X) "
            Case MC07_Y
                StrMsg = "(Y) "
            Case MC07_Z
                StrMsg = "(Z) "
            Case MC07_A
                StrMsg = "(A) "
        End Select

        '*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
        If (MC07_BWaitDriveCommand(hDevice, 1000, sResult) = False) Then
            Label_Message.Text = StrMsg & "It failed in MC07_BWaitDriveCommand() : MC07_Result(1)=" & Str(sResult.MC07_Result(1))

            Exit Function
        End If

        '*** READ STATUS1 ***
        If (MC07_BRStatus1(hDevice, Status1, sResult) = False) Then
            Label_Message.Text = StrMsg & "It failed in MC07_BRStatus1() : MC07_Result(1)=" & Str(sResult.MC07_Result(1))

            Exit Function
        End If

        '*** CHECK STATUS1 ERROR BIT = 0 ***
        If Status1 And &H10S Then
            '*** READ ERROR STATUS ***
            Cmd = &HD1S
            WData = 0
            If (MC07_LWRDrive(hDevice, Cmd, WData, RData, sResult) = False) Then
                Label_Message.Text = StrMsg & "It failed in MC07_LWRDrive(H'" & Hex(Cmd) & ") : MC07_Result(1)=" & Str(sResult.MC07_Result(1))

                Exit Function
            End If

            'GET DRIVE DATA1 PORT
            RData = RData And &HFFFF

            Label_Message.Text = StrMsg & "STATUS1 ERROR = 1 : ERROR STATUS = H'" & Hex(RData) & vbCrLf _
                                    & "Please click 'Clrear Error'"

            Exit Function

        End If

        CheckStatus1 = True

    End Function

    '********************************************************************************************************************
    '
    '   Check Status1 PORT.
    '   Parameter hDevice         ･･･ Device Handle
    '   Return Value              ･･･ TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0
    '                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1
    '********************************************************************************************************************
    Private Function CheckStatus1Int(ByVal hDevice As Integer) As Boolean
        Dim sResult As New MC07_S_RESULT()
        Dim Status1 As Short

        sResult.Initialize()

        CheckStatus1Int = False

        '*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
        If (MC07_BWaitDriveCommand(hDevice, 1000, sResult) = False) Then
            Exit Function
        End If

        '*** READ STATUS1 ***
        If (MC07_BRStatus1(hDevice, Status1, sResult) = False) Then
            Exit Function
        End If

        '*** CHECK STATUS1 ERROR BIT = 0 ***
        If Status1 And &H10S Then
            Exit Function
        End If
        CheckStatus1Int = True

    End Function

    '****************************************************************************************************************
    '
    '   Setting the condition of the button in drive condition.
    '
    '****************************************************************************************************************
    Private Sub ButtonDisable()
        Button_CallBack.Enabled = False
        Button_Event.Enabled = False
        Button_SlowStop.Enabled = True
        Button_FastStop.Enabled = True
        Button_Open.Enabled = False
        Button_Close.Enabled = False
        Button_ClearError.Enabled = True
        Button_End.Enabled = False
    End Sub

    '****************************************************************************************************************
    '
    '   Setting the condition of the button in not drive condition.
    '
    '****************************************************************************************************************
    Private Sub ButtonEnable()
        Button_CallBack.Enabled = True
        Button_Event.Enabled = True
        Button_SlowStop.Enabled = True
        Button_FastStop.Enabled = True
        Button_Open.Enabled = False
        Button_Close.Enabled = True
        Button_ClearError.Enabled = True
        Button_End.Enabled = False
    End Sub

    '****************************************************************************************************************
    '
    '   The processing that Function Error has happened.
    '
    '****************************************************************************************************************
    Private Sub ErrorOperation()
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()
        '***  All Axes : Close Device Int ***
        RetX = MC07_CloseDevInt(hDevX, sResultX)
        RetY = MC07_CloseDevInt(hDevY, sResultY)
        RetZ = MC07_CloseDevInt(hDevZ, sResultZ)
        RetA = MC07_CloseDevInt(hDevA, sResultA)

        '***  All Axes : Clear Device Int ***
        RetX = MC07_ClearIntSet(hDevX, sResultX)
        RetY = MC07_ClearIntSet(hDevY, sResultY)
        RetZ = MC07_ClearIntSet(hDevZ, sResultZ)
        RetA = MC07_ClearIntSet(hDevA, sResultA)
    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Form1 is loaded.
    '
    '****************************************************************************************************************
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Button_CallBack.Enabled = False
        Button_Event.Enabled = False
        Button_SlowStop.Enabled = False
        Button_FastStop.Enabled = False
        Button_Open.Enabled = True
        Button_Close.Enabled = False
        Button_ClearError.Enabled = False
        Button_End.Enabled = True

    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Open Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Open.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()

        Label_MessageX.Text = ""
        Label_MessageY.Text = ""
        Label_MessageZ.Text = ""
        Label_MessageA.Text = ""
        Label_Message.Text = ""

        '*** DEVICE OPEN ***
        RetX = MC07_BOpen(0, MC07_X, hDevX, sResultX)
        RetY = MC07_BOpen(0, MC07_Y, hDevY, sResultY)
        RetZ = MC07_BOpen(0, MC07_Z, hDevZ, sResultZ)
        RetA = MC07_BOpen(0, MC07_A, hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BOpen()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            RetX = MC07_BClose(hDevX, sResultX)
            RetY = MC07_BClose(hDevY, sResultY)
            RetZ = MC07_BClose(hDevZ, sResultZ)
            RetA = MC07_BClose(hDevA, sResultA)
            Exit Sub
        End If

        Call ButtonEnable()

        Timer1.Enabled = True

    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Close Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Close.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()

        Timer1.Enabled = False

        '*** DEVICE CLOSE ***
        RetX = MC07_BClose(hDevX, sResultX)
        RetY = MC07_BClose(hDevY, sResultY)
        RetZ = MC07_BClose(hDevZ, sResultZ)
        RetA = MC07_BClose(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BClose()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If

        Label_MessageX.Text = ""
        Label_MessageY.Text = ""
        Label_MessageZ.Text = ""
        Label_MessageA.Text = ""
        Label_Message.Text = ""

        Button_CallBack.Enabled = False
        Button_Event.Enabled = False
        Button_SlowStop.Enabled = False
        Button_FastStop.Enabled = False
        Button_Open.Enabled = True
        Button_Close.Enabled = False
        Button_ClearError.Enabled = False
        Button_End.Enabled = True

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the Clear Error Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_ClearError_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ClearError.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()

        '*** All Axes : ERROR CLEAR ***
        RetX = MC07_ClrError(hDevX, sResultX)
        RetY = MC07_ClrError(hDevY, sResultY)
        RetZ = MC07_ClrError(hDevZ, sResultZ)
        RetA = MC07_ClrError(hDevA, sResultA)

        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_ClrError()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If

        Label_Message.Text = "MC07_ClrError() succeed"

    End Sub

    '********************************************************************************************************************
    '
    '   The processing that the End Button was clicked.
    '
    '********************************************************************************************************************
    Private Sub Button_End_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_End.Click
        End

    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Slow Stop Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_SlowStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_SlowStop.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean
        Dim Cmd As Short

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()
        '*** SLOW STOP COMMAND ***
        Cmd = &HFE
        RetX = MC07_BWDriveCommand(hDevX, Cmd, sResultX)
        RetY = MC07_BWDriveCommand(hDevY, Cmd, sResultY)
        RetZ = MC07_BWDriveCommand(hDevZ, Cmd, sResultZ)
        RetA = MC07_BWDriveCommand(hDevA, Cmd, sResultA)

        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BWDriveCommand(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If

    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Fast Stop Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_FastStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_FastStop.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX As Boolean
        Dim RetY As Boolean
        Dim RetZ As Boolean
        Dim RetA As Boolean
        Dim Cmd As Short

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()
        '*** FAST STOP COMMAND ***
        Cmd = &HFF
        RetX = MC07_BWDriveCommand(hDevX, Cmd, sResultX)
        RetY = MC07_BWDriveCommand(hDevY, Cmd, sResultY)
        RetZ = MC07_BWDriveCommand(hDevZ, Cmd, sResultZ)
        RetA = MC07_BWDriveCommand(hDevA, Cmd, sResultA)

        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BWDriveCommand(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If


    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Timer1.
    '
    '****************************************************************************************************************
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Call NowAddressDisplay(hDevX, Label_MessageX)
        Call NowAddressDisplay(hDevY, Label_MessageY)
        Call NowAddressDisplay(hDevZ, Label_MessageZ)
        Call NowAddressDisplay(hDevA, Label_MessageA)

    End Sub


    '****************************************************************************************************************
    '
    '   The processing that the CallBack Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_CallBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_CallBack.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX, RetY, RetZ, RetA As Boolean
        Dim StatusX, StatusY, StatusZ, StatusA As Short
        Dim LData As Integer
        Dim Cmd As Short

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()

        Label_MessageX.Text = ""
        Label_MessageY.Text = ""
        Label_MessageZ.Text = ""
        Label_MessageA.Text = ""

        DriveEndFlagX = 1
        DriveEndFlagY = 1
        DriveEndFlagZ = 1
        DriveEndFlagA = 1

        ' AbnormalEndFlg = OFF
        AbnormalEndFlag = 0

        '*** All Axes : STATUS1 READ ***
        RetX = MC07_BRStatus1(hDevX, StatusX, sResultX)
        RetY = MC07_BRStatus1(hDevY, StatusY, sResultY)
        RetZ = MC07_BRStatus1(hDevZ, StatusZ, sResultZ)
        RetA = MC07_BRStatus1(hDevA, StatusA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BRStatus1(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If

        Status1X = CInt(StatusX)
        Status1Y = CInt(StatusY)
        Status1Z = CInt(StatusZ)
        Status1A = CInt(StatusA)

        Label_Message.Text = "CallBack Int Demonstration Start"

        Call ButtonDisable()

        '*** All Axes: ADDRESS COUNTER = 0 *** 
        Cmd = &H80S
        LData = 0
        RetX = MC07_LWDrive(hDevX, Cmd, LData, sResultX)
        RetY = MC07_LWDrive(hDevY, Cmd, LData, sResultY)
        RetZ = MC07_LWDrive(hDevZ, Cmd, LData, sResultZ)
        RetA = MC07_LWDrive(hDevA, Cmd, LData, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER1 = 10000 ***
        Cmd = &H88S
        LData = 10000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER2 = 20000 ***
        Cmd = &H89S
        LData = 20000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER3 = 30000 ***
        Cmd = &H8AS
        LData = 30000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER INITIALIZE1 COMMAND ***
        '*** D8 :ADRINT TYPE0 = 1
        '*** D9 :ADRINT TYPE1 = 1
        Cmd = &H81S
        LData = &H330
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** X Axis : ADDRESS COUNTER INITIALIZE2 COMMAND ***
        '*** D0 :COMP1 INT ENABLE = 1
        '*** D4 :COMP2 INT ENABLE = 1
        '*** D8 :COMP3 INT ENABLE = 1
        Cmd = &H82S
        LData = &H111
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** All Axes : SPEC INITIALIZE2 COMMAND ***
        '*** D4 :RDYINT TYPE0 = 0
        '*** D5 :RDYINT TYPE1 = 0
        Cmd = &H2S
        LData = &HF00
        If (CheckStatus1(hDevX, MC07_X) = False) Then Call ButtonEnable() : Exit Sub
        RetX = MC07_LWDrive(hDevX, Cmd, LData, sResultX)
        If (CheckStatus1(hDevY, MC07_Y) = False) Then Call ButtonEnable() : Exit Sub
        RetY = MC07_LWDrive(hDevY, Cmd, LData, sResultY)
        If (CheckStatus1(hDevZ, MC07_Z) = False) Then Call ButtonEnable() : Exit Sub
        RetZ = MC07_LWDrive(hDevZ, Cmd, LData, sResultZ)
        If (CheckStatus1(hDevA, MC07_A) = False) Then Call ButtonEnable() : Exit Sub
        RetA = MC07_LWDrive(hDevA, Cmd, LData, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : MC07_SetIntCallBack (ADYINT)   ***
        If (MC07_SetIntCallBack(hDevX, MC07_INT_FACTOR_ADRINT, XAdrIntCallBack, 0, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_SetIntCallBack() : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** All Axes : SetIntCallBack (RDYINT)   ***
        RetX = MC07_SetIntCallBack(hDevX, MC07_INT_FACTOR_RDYINT, XRdyIntCallBack, MC07_X, sResultX)
        RetY = MC07_SetIntCallBack(hDevY, MC07_INT_FACTOR_RDYINT, YRdyIntCallBack, MC07_Y, sResultY)
        RetZ = MC07_SetIntCallBack(hDevZ, MC07_INT_FACTOR_RDYINT, ZRdyIntCallBack, MC07_Z, sResultZ)
        RetA = MC07_SetIntCallBack(hDevA, MC07_INT_FACTOR_RDYINT, ARdyIntCallBack, MC07_A, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_SetIntCallBack()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))
            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If

        '*** All Axes : Open DevInt   ***
        RetX = MC07_OpenDevInt(hDevX, sResultX)
        RetY = MC07_OpenDevInt(hDevY, sResultY)
        RetZ = MC07_OpenDevInt(hDevZ, sResultZ)
        RetA = MC07_OpenDevInt(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_OpenDevInt()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : ABSOLUTE INDEX DRIVE COMMAND (50000)***
        Cmd = &H15S
        LData = 50000
        If (CheckStatus1(hDevX, MC07_X) = False) Then
            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub

        End If
        ' X Axis : DriveEndFlg = OFF
        DriveEndFlagX = 0

        '*** All Axes : Wait Event Int Demonstration End ***
        Do
            Application.DoEvents()
        Loop While (((DriveEndFlagX <> 0) And (DriveEndFlagY <> 0) And (DriveEndFlagZ <> 0) And (DriveEndFlagA <> 0)) = False)

        ' Display Drive End Status
        If (AbnormalEndFlag = 1) Then
            Label_Message.Text = "Abnormanl End" & vbCrLf & ": X : Status1 = H'" & Hex(Status1X) _
                                & vbCrLf & ": Y : Status1 = H'" & Hex(Status1Y) _
                                & vbCrLf & ": Z : Status1 = H'" & Hex(Status1Z) _
                                & vbCrLf & ": A : Status1 = H'" & Hex(Status1A)
        Else
            Label_Message.Text = "CallBack Int Demonstration End"
        End If

        '***  All Axes : Close Device Int ***
        RetX = MC07_CloseDevInt(hDevX, sResultX)
        RetY = MC07_CloseDevInt(hDevY, sResultY)
        RetZ = MC07_CloseDevInt(hDevZ, sResultZ)
        RetA = MC07_CloseDevInt(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_CloseDevInt()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If


        '***  All Axes : Clear Device Int ***
        RetX = MC07_ClearIntSet(hDevX, sResultX)
        RetY = MC07_ClearIntSet(hDevY, sResultY)
        RetZ = MC07_ClearIntSet(hDevZ, sResultZ)
        RetA = MC07_ClearIntSet(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_ClearIntSet()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If

        Call ButtonEnable()
    End Sub

    '****************************************************************************************************************
    '
    '	X Axis : ADRINT CallBack 
    '
    '****************************************************************************************************************
    Private Sub AdrIntCallBackX(ByVal Status As Integer, ByVal Dummy As Integer)
        Dim Cmd As Short
        Dim LData As Integer
        Dim sResult As New MC07_S_RESULT()

        sResult.Initialize()

        '*** ADDRESS COUNTER COMPARE REGISTER1 ---> Y Axis : ABSOLUTE INDEX DRIVE(10000) ***
        If (Status And &H1) <> 0 Then
            Cmd = &H15
            LData = 10000
            If (CheckStatus1Int(hDevY) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If

            If (MC07_LWDrive(hDevY, Cmd, LData, sResult) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If
            ' Y Axis : DriveEndFlg = OFF
            DriveEndFlagY = 0

            '*** ADDRESS COUNTER COMPARE REGISTER2 ---> Z Axis : ABSOLUTE INDEX DRIVE(10000) ***
        ElseIf (Status And &H2) <> 0 Then
            Cmd = &H15
            LData = 10000
            If (CheckStatus1Int(hDevZ) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If

            If (MC07_LWDrive(hDevZ, Cmd, LData, sResult) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If
            ' Z Axis : DriveEndFlg = OFF
            DriveEndFlagZ = 0
            '*** ADDRESS COUNTER COMPARE REGISTER3 ---> A Axis : ABSOLUTE INDEX DRIVE(10000) ***
        ElseIf (Status And &H4) <> 0 Then
            Cmd = &H15
            LData = 10000
            If (CheckStatus1Int(hDevA) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If

            If (MC07_LWDrive(hDevA, Cmd, LData, sResult) = False) Then
                AbnormalEndFlag = 1
                Exit Sub
            End If
            ' A Axis : DriveEndFlg = OFF
            DriveEndFlagA = 0
        End If
    End Sub

    '****************************************************************************************************************
    '
    '	All Axes : RDYINT CallBack 
    '
    '****************************************************************************************************************
    Private Sub RdyIntCallBack(ByVal Status As Integer, ByVal Axis As Integer)
        ' Check Abnormal End
        If (Status And &HF0) Then AbnormalEndFlag = 1

        ' Normal End
        If (Axis = MC07_X) Then
            Status1X = Status : DriveEndFlagX = 1
        ElseIf (Axis = MC07_Y) Then
            Status1Y = Status : DriveEndFlagY = 1
        ElseIf (Axis = MC07_Z) Then
            Status1Z = Status : DriveEndFlagZ = 1
        ElseIf (Axis = MC07_A) Then
            Status1A = Status : DriveEndFlagA = 1
        End If
    End Sub

    '****************************************************************************************************************
    '
    '   The processing that the Event Button was clicked.
    '
    '****************************************************************************************************************
    Private Sub Button_Event_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Event.Click
        Dim sResultX As New MC07_S_RESULT()
        Dim sResultY As New MC07_S_RESULT()
        Dim sResultZ As New MC07_S_RESULT()
        Dim sResultA As New MC07_S_RESULT()
        Dim RetX, RetY, RetZ, RetA As Boolean
        Dim StatusX, StatusY, StatusZ, StatusA As Short
        Dim LData As Integer
        Dim Cmd As Short

        sResultX.Initialize() : sResultY.Initialize()
        sResultZ.Initialize() : sResultA.Initialize()

        Label_MessageX.Text = ""
        Label_MessageY.Text = ""
        Label_MessageZ.Text = ""
        Label_MessageA.Text = ""

        DriveEndFlagX = 1
        DriveEndFlagY = 1
        DriveEndFlagZ = 1
        DriveEndFlagA = 1

        Application.DoEvents()

        ' AbnormalEndFlg = OFF
        AbnormalEndFlag = 0

        '*** All Axes : STATUS1 READ ***
        RetX = MC07_BRStatus1(hDevX, StatusX, sResultX)
        RetY = MC07_BRStatus1(hDevY, StatusY, sResultY)
        RetZ = MC07_BRStatus1(hDevZ, StatusZ, sResultZ)
        RetA = MC07_BRStatus1(hDevA, StatusA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_BRStatus1()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Exit Sub
        End If

        Status1X = CInt(StatusX)
        Status1Y = CInt(StatusY)
        Status1Z = CInt(StatusZ)
        Status1A = CInt(StatusA)

        Label_Message.Text = "Event Int Demonstration Start"

        Call ButtonDisable()

        '*** All Axes: ADDRESS COUNTER = 0 *** 
        Cmd = &H80S
        LData = 0
        RetX = MC07_LWDrive(hDevX, Cmd, LData, sResultX)
        RetY = MC07_LWDrive(hDevY, Cmd, LData, sResultY)
        RetZ = MC07_LWDrive(hDevZ, Cmd, LData, sResultZ)
        RetA = MC07_LWDrive(hDevA, Cmd, LData, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER1 = 10000 ***
        Cmd = &H88S
        LData = 10000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER2 = 20000 ***
        Cmd = &H89S
        LData = 20000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER COMPARE REGISTER3 = 30000 ***
        Cmd = &H8AS
        LData = 30000
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If


        '*** X Axis : ADDRESS COUNTER INITIALIZE1 COMMAND ***
        '*** D8 :ADRINT TYPE0 = 1
        '*** D9 :ADRINT TYPE1 = 1
        Cmd = &H81S
        LData = &H330
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** X Axis : ADDRESS COUNTER INITIALIZE2 COMMAND ***
        '*** D0 :COMP1 INT ENABLE = 1
        '*** D4 :COMP2 INT ENABLE = 1
        '*** D8 :COMP3 INT ENABLE = 1
        Cmd = &H82S
        LData = &H111
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** All Axes : SPEC INITIALIZE2 COMMAND ***
        '*** D4 :RDYINT TYPE0 = 0
        '*** D5 :RDYINT TYPE1 = 0
        Cmd = &H2S
        LData = &HF00
        If (CheckStatus1(hDevX, MC07_X) = False) Then Call ButtonEnable() : Exit Sub
        RetX = MC07_LWDrive(hDevX, Cmd, LData, sResultX)
        If (CheckStatus1(hDevY, MC07_Y) = False) Then Call ButtonEnable() : Exit Sub
        RetY = MC07_LWDrive(hDevY, Cmd, LData, sResultY)
        If (CheckStatus1(hDevZ, MC07_Z) = False) Then Call ButtonEnable() : Exit Sub
        RetZ = MC07_LWDrive(hDevZ, Cmd, LData, sResultZ)
        If (CheckStatus1(hDevA, MC07_A) = False) Then Call ButtonEnable() : Exit Sub
        RetA = MC07_LWDrive(hDevA, Cmd, LData, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ")" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : SetIntEvent (ADYINT)   ***
        hAdrEvent = CreateEvent(Nothing, False, False, Nothing)

        If (MC07_SetIntEvent(hDevX, MC07_INT_FACTOR_ADRINT, hAdrEvent, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_SetIntEvent() : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ButtonEnable()
            Exit Sub

        End If

        '*** All Axes : Set IntEvent (RDYINT)   ***
        hXRdyEvent = CreateEvent(Nothing, False, False, Nothing)
        hYRdyEvent = CreateEvent(Nothing, False, False, Nothing)
        hZRdyEvent = CreateEvent(Nothing, False, False, Nothing)
        hARdyEvent = CreateEvent(Nothing, False, False, Nothing)
        RetX = MC07_SetIntEvent(hDevX, MC07_INT_FACTOR_RDYINT, hXRdyEvent, sResultX)
        RetY = MC07_SetIntEvent(hDevY, MC07_INT_FACTOR_RDYINT, hYRdyEvent, sResultY)
        RetZ = MC07_SetIntEvent(hDevZ, MC07_INT_FACTOR_RDYINT, hZRdyEvent, sResultZ)
        RetA = MC07_SetIntEvent(hDevA, MC07_INT_FACTOR_RDYINT, hARdyEvent, sResultA)

        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_SetIntEvent()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))
            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If


        '*** All Axes : Open DevInt   ***
        RetX = MC07_OpenDevInt(hDevX, sResultX)
        RetY = MC07_OpenDevInt(hDevY, sResultY)
        RetZ = MC07_OpenDevInt(hDevZ, sResultZ)
        RetA = MC07_OpenDevInt(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_OpenDevInt()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If

        '*** X Axis : ABSOLUTE INDEX DRIVE COMMAND (50000)***
        Cmd = &H15S
        LData = 50000
        If (CheckStatus1(hDevX, MC07_X) = False) Then
            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If
        If (MC07_LWDrive(hDevX, Cmd, LData, sResultX) = False) Then
            Label_Message.Text = "(X)It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result[1]=" & Str(sResultX.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub

        End If
        ' X Axis : DriveEndFlg = OFF
        DriveEndFlagX = 0

        AdrThreadEndFlag = 0
        XThreadEndFlag = 0
        YThreadEndFlag = 0
        ZThreadEndFlag = 0
        AThreadEndFlag = 0

        '*** All Axes : Creat Controll Drive Thread ***
        AdrThread = New System.Threading.Thread(AddressOf XAdrIntDriveControlThread)
        XThread = New System.Threading.Thread(AddressOf XDriveControlThread)
        YThread = New System.Threading.Thread(AddressOf YDriveControlThread)
        ZThread = New System.Threading.Thread(AddressOf ZDriveControlThread)
        AThread = New System.Threading.Thread(AddressOf ADriveControlThread)
        AdrThread.IsBackground = True
        XThread.IsBackground = True
        YThread.IsBackground = True
        ZThread.IsBackground = True
        AThread.IsBackground = True

        AdrThread.Start()
        XThread.Start()
        YThread.Start()
        ZThread.Start()
        AThread.Start()

        '*** All Axes : Wait Event Int Demonstration End ***
        Do
            Application.DoEvents()
        Loop While (((DriveEndFlagX <> 0) And (DriveEndFlagY <> 0) And (DriveEndFlagZ <> 0) And (DriveEndFlagA <> 0)) = False)

        Application.DoEvents()

        ' Display Drive End Status
        If (AbnormalEndFlag = 1) Then
            Label_Message.Text = "Abnormanl End" & vbCrLf & ": X : Status1 = H'" & Hex(Status1X) _
                                & vbCrLf & ": Y : Status1 = H'" & Hex(Status1Y) _
                                & vbCrLf & ": Z : Status1 = H'" & Hex(Status1Z) _
                                & vbCrLf & ": A : Status1 = H'" & Hex(Status1A)
        Else
            Label_Message.Text = "Event Int Demonstration End"
        End If

        '***  All Axes : Close Device Int ***
        RetX = MC07_CloseDevInt(hDevX, sResultX)
        RetY = MC07_CloseDevInt(hDevY, sResultY)
        RetZ = MC07_CloseDevInt(hDevZ, sResultZ)
        RetA = MC07_CloseDevInt(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_CloseDevInt()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If


        '***  All Axes : Clear Device Int ***
        RetX = MC07_ClearIntSet(hDevX, sResultX)
        RetY = MC07_ClearIntSet(hDevY, sResultY)
        RetZ = MC07_ClearIntSet(hDevZ, sResultZ)
        RetA = MC07_ClearIntSet(hDevA, sResultA)
        If (RetX = False) Or (RetY = False) Or (RetZ = False) Or (RetA = False) Then
            Label_Message.Text = "It failed in MC07_ClearIntSet()" & vbCrLf & "X : MC07_Result[1]=" & Str(sResultX.MC07_Result(1)) &
                                vbCrLf & "Y : MC07_Result[1]=" & Str(sResultY.MC07_Result(1)) &
                                vbCrLf & "Z : MC07_Result[1]=" & Str(sResultZ.MC07_Result(1)) &
                                vbCrLf & "A : MC07_Result[1]=" & Str(sResultA.MC07_Result(1))

            Call ErrorOperation()
            Call ButtonEnable()
            Exit Sub
        End If

        Call ButtonEnable()
    End Sub

    '*******************************************************************************************************************
    '
    '	X Axis : ADYINT THREAD
    '
    '*******************************************************************************************************************
    Private Sub XAdrIntDriveControlThread()
        Dim sResult As New MC07_S_RESULT()
        Dim LData, hDevice As Integer
        Dim Cmd, Status, i As Short

        sResult.Initialize()

        For i = 0 To 2
            Do
                '*** Wait X Axis : XADRINT EVENT ***
                If (WaitForSingleObject(hAdrEvent, 10) = WAIT_OBJECT_0) Then Exit Do
            Loop While (AdrThreadEndFlag = 0)

            '*** Check Thread End Flag ***
            If (AdrThreadEndFlag = 1) Then Exit Sub

            If (MC07_ReadIntStatus(hDevX, MC07_INT_FACTOR_ADRINT, Status, sResult) = False) Then
                AbnormalEndFlag = 1
                Exit For
            End If

            '*** ADDRESS COUNTER COMPARE REGISTER1 ---> Y Axis : ABSOLUTE INDEX DRIVE(10000) ***
            If (Status And &H1) <> 0 Then
                hDevice = hDevY
                '*** ADDRESS COUNTER COMPARE REGISTER2 ---> Z Axis : ABSOLUTE INDEX DRIVE(10000) ***
            ElseIf (Status And &H2) <> 0 Then
                hDevice = hDevZ
                '*** ADDRESS COUNTER COMPARE REGISTER3 ---> A Axis : ABSOLUTE INDEX DRIVE(10000) ***
            ElseIf (Status And &H4) <> 0 Then
                hDevice = hDevA
            End If

            '*** ABSOLUTE INDEX DRIVE ***
            Cmd = &H15
            LData = 10000
            If (CheckStatus1Int(hDevice) = False) Then
                AbnormalEndFlag = 1
                Exit For
            End If

            If (MC07_LWDrive(hDevice, Cmd, LData, sResult) = False) Then
                AbnormalEndFlag = 1
                Exit For
            End If

            If (Status And &H1) <> 0 Then
                DriveEndFlagY = 0
            ElseIf (Status And &H2) <> 0 Then
                DriveEndFlagZ = 0
            ElseIf (Status And &H4) <> 0 Then
                DriveEndFlagA = 0
            End If
        Next i

    End Sub

    '*******************************************************************************************************************
    '
    '	X Axis : RDYINT THREAD
    '
    '*******************************************************************************************************************
    Private Sub XDriveControlThread()

        Dim sResult As New MC07_S_RESULT()
        Dim Status As Integer

        sResult.Initialize()

        Do
            '*** Wait RDYINT EVENT ***
            If (WaitForSingleObject(hXRdyEvent, 10) = WAIT_OBJECT_0) Then Exit Do
        Loop While (XThreadEndFlag = 0)

        '*** Check Thread End Flag ***
        If (XThreadEndFlag = 1) Then Exit Sub

        If (MC07_ReadIntStatus(hDevX, MC07_INT_FACTOR_RDYINT, Status, sResult) = False) Then
            AbnormalEndFlag = 1
            DriveEndFlagX = 1
            Exit Sub
        End If

        '*** Check Drive End Status ***
        If (Status And &HF0) <> 0 Then

            'Because Stop ADRINT Thead
            AdrThreadEndFlag = 1 : AdrThread.Join()

            ' Because Stop RDYINT Thread
            If (DriveEndFlagY = 1) Then YThreadEndFlag = 1 : YThread.Join()
            If (DriveEndFlagZ = 1) Then ZThreadEndFlag = 1 : ZThread.Join()
            If (DriveEndFlagA = 1) Then AThreadEndFlag = 1 : AThread.Join()

            AbnormalEndFlag = 1
        End If

        Status1X = Status
        DriveEndFlagX = 1

    End Sub

    '*******************************************************************************************************************
    '
    '	Y Axis : RDYINT THREAD
    '
    '*******************************************************************************************************************
    Private Sub YDriveControlThread()
        Dim sResult As New MC07_S_RESULT()
        Dim Status As Integer

        sResult.Initialize()
        Do
            '*** Wait RDYINT EVENT ***
            If (WaitForSingleObject(hYRdyEvent, 10) = WAIT_OBJECT_0) Then Exit Do
        Loop While (YThreadEndFlag = 0)

        '*** Check Thread End Flag ***
        If (YThreadEndFlag = 1) Then Exit Sub

        If (MC07_ReadIntStatus(hDevY, MC07_INT_FACTOR_RDYINT, Status, sResult) = False) Then
            AbnormalEndFlag = 1
            DriveEndFlagY = 1
            Exit Sub
        End If

        '*** Check Drive End Status ***
        If (Status And &HF0) <> 0 Then AbnormalEndFlag = 1

        Status1Y = Status
        DriveEndFlagY = 1

    End Sub

    '*******************************************************************************************************************
    '
    '	Z Axis : RDYINT THREAD
    '
    '*******************************************************************************************************************
    Private Sub ZDriveControlThread()
        Dim sResult As New MC07_S_RESULT()
        Dim Status As Integer

        sResult.Initialize()
        Do
            '*** Wait RDYINT EVENT ***
            If (WaitForSingleObject(hZRdyEvent, 10) = WAIT_OBJECT_0) Then Exit Do
        Loop While (ZThreadEndFlag = 0)

        '*** Check Thread End Flag ***
        If (ZThreadEndFlag = 1) Then Exit Sub

        If (MC07_ReadIntStatus(hDevZ, MC07_INT_FACTOR_RDYINT, Status, sResult) = False) Then
            AbnormalEndFlag = 1
            DriveEndFlagZ = 1
            Exit Sub
        End If

        '*** Check Drive End Status ***
        If (Status And &HF0) <> 0 Then AbnormalEndFlag = 1

        Status1Z = Status
        DriveEndFlagZ = 1
    End Sub

    '*******************************************************************************************************************
    '
    '	A Axis : RDYINT THREAD
    '
    '*******************************************************************************************************************
    Public Sub ADriveControlThread()
        Dim sResult As New MC07_S_RESULT()
        Dim Status As Integer

        sResult.Initialize()
        Do
            '*** Wait RDYINT EVENT ***
            If (WaitForSingleObject(hARdyEvent, 10) = WAIT_OBJECT_0) Then Exit Do
        Loop While (AThreadEndFlag = 0)

        '*** Check Thread End Flag ***
        If (AThreadEndFlag = 1) Then Exit Sub

        If (MC07_ReadIntStatus(hDevA, MC07_INT_FACTOR_RDYINT, Status, sResult) = False) Then
            AbnormalEndFlag = 1
            DriveEndFlagA = 1
            Exit Sub
        End If

        '*** Check Drive End Status ***
        If (Status And &HF0) <> 0 Then AbnormalEndFlag = 1

        Status1A = Status
        DriveEndFlagA = 1
    End Sub

End Class