/******************************************************************************

	definitions, types, functions for Visual C++		5.3101.11.2206

******************************************************************************/

//*** user-supplied callback routioe pointer ***
typedef void ( WINAPI *PLPMC07CALLBACK )( DWORD Status, DWORD UserData );

//*** RESULT STRUCTURE ***
typedef struct MC07_TAG_S_RESULT {
	WORD			MC07_Result[4];
} MC07_S_RESULT;

//*** DATA STRUCTURE ***
typedef struct MC07_TAG_S_DATA {
	WORD			MC07_Data[4];
} MC07_S_DATA;

//*** XY POSITION STRUCTURE ***
typedef struct _MC07_S_XY_POSITION {
	LONG			X;
	LONG			Y;
} MC07_S_XY_POSITION;

//*** SPEED SETUP STRUCTURE ***
typedef struct _MC07_S_SPEED_RATE {
	DWORD			FSpd;
	DWORD			HighSpeed;
	DWORD			LowSpeed;
	DWORD			EndLowSpeed;
	DWORD			SUArea;
	DWORD			SDArea;
	DWORD			URateNo;
	DWORD			DRateNo;
} MC07_S_SPEED_RATE;

//*** ORG PARAMETER STRUCTURE ***
typedef struct MC07_TAG_S_ORG_PARAM {
	DWORD			Spec;
	DWORD			MarginPulse;
	DWORD			LimitDelay;
	DWORD			ScanDelay;
	DWORD			PulseDelay;
	DWORD			CScanErrorPulse;
	DWORD			PulseErrorPulse;
	DWORD			OffsetPulse;
	LONG			PresetPulse;
} MC07_S_ORG_PARAM;

//*** DEFINITION ***
#define MC07_X								0
#define MC07_Y								1
#define MC07_Z								2
#define MC07_A								3
#define MC07_B								4
#define MC07_C								5

#define MC07_X1								0
#define MC07_Y1								1
#define MC07_Z1								2
#define MC07_A1								3
#define MC07_B1								4
#define MC07_C1								5
#define MC07_X2								6
#define MC07_Y2								7
#define MC07_Z2								8
#define MC07_A2								9
#define MC07_B2								10
#define MC07_C2								11

#define MC07_ORG0							0
#define MC07_ORG1							1
#define MC07_ORG2							2
#define MC07_ORG3							3
#define MC07_ORG4							4
#define MC07_ORG5							5
#define MC07_ORG10							10
#define MC07_ORG11							11
#define MC07_ORG12							12

#define MC07_INT_FACTOR_RDYINT				0x0001
#define MC07_INT_FACTOR_STBY				0x0002
#define MC07_INT_FACTOR_COMREG_EP			0x0004
#define MC07_INT_FACTOR_nCOMREG_FL			0x0008
#define MC07_INT_FACTOR_MAN					0x0010
#define MC07_INT_FACTOR_DALM				0x0020
#define MC07_INT_FACTOR_SS0					0x0040
#define MC07_INT_FACTOR_SS1					0x0080
#define MC07_INT_FACTOR_ADRINT				0x0100
#define MC07_INT_FACTOR_CNTINT				0x0200
#define MC07_INT_FACTOR_DFLINT				0x0400
#define MC07_INT_FACTOR_ERRINT				0x0800
#define MC07_INT_FACTOR_OUT2				0x1000
#define MC07_INT_FACTOR_OUT3				0x2000
#define MC07_INT_FACTOR_GPIO0				0x4000
#define MC07_INT_FACTOR_GPIO1				0x8000

#define MC07_CCW							0
#define MC07_CW								1

#define MC07_IO_IN_PORT1					0x0000
#define MC07_IO_IN_PORT2					0x0001
#define MC07_IO_OUT_PORT1					0x0100
#define MC07_IO_OUT_PORT2					0x0101

/*** Function Prototype Declarations Exported ***/
#if !defined(_MC07FUNC_)
    #define MC07_API    __declspec( dllimport )
#else
    #define MC07_API    __declspec( dllexport )
#endif

#ifdef __cplusplus
extern"C"{
#endif

MC07_API BOOL	WINAPI MC07_Reset( WORD BoardNo, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ReadBoardType( WORD BoardNo, WORD *pBoardType, WORD *pVersion, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BOpen( WORD BoardNo, WORD Axis, DWORD *phDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BClose( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ClrError( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_LWDrive( DWORD hDev, WORD Cmd, DWORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_LWData( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_IWDrive( DWORD hDev, WORD Cmd, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_IWData( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWDriveCommand( DWORD hDev, WORD *pCmd, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRStatus1( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRStatus2( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRStatus3( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRStatus4( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRStatus5( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_LRDrive( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_IRDrive( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_LWRDrive( DWORD hDev, WORD Cmd, DWORD *pWriteData, DWORD *pReadData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWaitDriveCommand( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWaitComregNotFull( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BIsWait( DWORD hDev, WORD *pWaitSts, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BBreakWait( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetSpeedRate( DWORD hDev, WORD ResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ReadSpeedRate( DWORD hDev, WORD *pResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_McIncStrCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, MC07_S_XY_POSITION *psTragetPosition, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_McIncCirCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTragetPosition, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_GetCirShortPulse( WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTragetPosition, LONG *pShortPulse, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_GetCirCenterPosition( MC07_S_XY_POSITION *psPassPosition, MC07_S_XY_POSITION *psTragetPosition, WORD *pDir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_IncFromAbs( DWORD hDevX, DWORD hDevY, MC07_S_XY_POSITION *psAbsPosition, MC07_S_XY_POSITION *psIncPosition, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ReadOrgStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgSpec( DWORD hDev, WORD Spec, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgMarginPulse( DWORD hDev, DWORD MarginPulse, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgDelay( DWORD hDev, WORD LimitDelay, WORD ScanDelay, WORD PulseDelay, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgErrorPulse( DWORD hDev, DWORD CScanErrorPulse, DWORD PulseErrorPulse, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgOffsetPulse( DWORD hDev, DWORD OffsetPulse, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetOrgPresetPulse( DWORD hDev, LONG PresetPulse, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ReadOrgParam( DWORD hDev, MC07_S_ORG_PARAM *psOrgParam, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ResetOrgFlag( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_Org( DWORD hDev, WORD OrgType, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_OpenDevInt( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_CloseDevInt( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetIntCallBack( DWORD hDev, DWORD IntFactor, PLPMC07CALLBACK Func, DWORD UserData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetIntMessage( DWORD hDev, DWORD IntFactor, HWND hWnd, UINT Message, DWORD UserData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_SetIntEvent( DWORD hDev, DWORD IntFactor, HANDLE hEvent, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ReadIntStatus( DWORD hDev, DWORD IntFactor, DWORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_ClearIntSet( DWORD hDev, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_IWHardConfig( DWORD hDev, WORD Cmd, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWHardConfigCommand( DWORD hDev, WORD *pCmd, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWHardConfigData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWHardConfigData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BWHardConfigData3( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigPauseStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigStbyStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigSigStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BRHardConfigData3( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
MC07_API VOID	WINAPI MC07_SetData( DWORD Data, MC07_S_DATA *psData );
MC07_API DWORD	WINAPI MC07_GetData( MC07_S_DATA *psData );
MC07_API BOOL	WINAPI MC07_BPortOpen( WORD BoardNo, WORD IoPort, DWORD *phPort, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BPortClose( DWORD hPort, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BPortOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
MC07_API BOOL	WINAPI MC07_BPortIn( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
MC07_API WORD	WINAPI MC07_Unsigned16( SHORT Data );
MC07_API SHORT	WINAPI MC07_Signed16( WORD Data );
MC07_API DWORD	WINAPI MC07_Unsigned32( LONG Data );
MC07_API LONG	WINAPI MC07_Signed32( DWORD Data );

#ifdef __cplusplus
}
#endif