﻿using System;
using System.Drawing;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data;
using MELEC;

namespace MplSample
{
    
    public partial class FormMplSample : Form
    {
     
        public FormMplSample()
        {
            InitializeComponent();
        }


        //***********************************************************************************************************
        //
        //   C#.NET Sample Program                5.2801.23.2309                      
        //
        //***********************************************************************************************************

        private static uint hDev;                                   // Device Handle
        private static uint hInPort1;                               // IN Port Handle
        private static uint hOutPort1;                              // OUT Port Handle


        //***********************************************************************************************************
        //
        //   The processing that the Open button was clicked.
        //
        //***********************************************************************************************************
        private void button_Open_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            label_Message.Text = "";

            //DEVICE OPEN
            if (MC07.BOpen(0, MC07.MC07_X, ref hDev, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07_BOpen() : MC07_Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }
            button_Open.Enabled = false;
            button_Close.Enabled = true;
            button_End.Enabled = false;
            button_Reset.Enabled = true;
            button_FastStop.Enabled = true;
            button_SlowStop.Enabled = true;
            button_DataSet.Enabled = true;
            button_Ccw_Scan.Enabled = true;
            button_Cw_Scan.Enabled = true;
            button_Org.Enabled = true;
            button_Rtn.Enabled = true;
            button_Ccw_Index.Enabled = true;
            button_Cw_Index.Enabled = true;
            button_Demo.Enabled = true;
            button_ClrError.Enabled = true;
            Now_Address_Display(hDev);                                 // Position address is displayed.;

        }

        //***********************************************************************************************************
        //
        //   The processing that the Close button was clicked.
        //
        //***********************************************************************************************************
        private void button_Close_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            label_Message.Text = "";
            //*** DEVICE CLOSE ***
            if (MC07.BClose(hDev, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07_BClose() : MC07_Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Open.Enabled = true;
            button_Close.Enabled = false;
            button_End.Enabled = true;
            button_Reset.Enabled = false;
            button_FastStop.Enabled = false;
            button_SlowStop.Enabled = false;
            button_DataSet.Enabled = false;
            button_Ccw_Scan.Enabled = false;
            button_Cw_Scan.Enabled = false;
            button_Org.Enabled = false;
            button_Rtn.Enabled = false;
            button_Ccw_Index.Enabled = false;
            button_Cw_Index.Enabled = false;
            button_Demo.Enabled = false;
            button_ClrError.Enabled = false;
            label_NowAddress.Text = "Please open the device.";


        }

        //***********************************************************************************************************
        //
        //   The processing that the End button was clicked.
        //
        //***********************************************************************************************************
        private void button_End_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        //***********************************************************************************************************
        //
        //   The processing that the Reset button was clicked.
        //
        //***********************************************************************************************************
        private void button_Reset_Click(object sender, EventArgs e)
        {
            uint LData = 0;
            ushort Cmd = 0;
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            label_Message.Text = "";
            //*** ADDRESS COUNTER PRESET ***
            Cmd = 0x80;
            LData = 0;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07_LWDrive(H'" + Cmd.ToString("X") + ") : MC07_Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            Now_Address_Display(hDev);

        }

        //***********************************************************************************************************
        //
        //   The processing that the FastStop button was clicked.
        //
        //***********************************************************************************************************
        private void button_FastStop_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;

            //*** FAST STOP COMMAND ***
            Cmd = 0xFF;
            if (MC07.BWDriveCommand(hDev, ref Cmd, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07_BWDriveCommand(H'" + Cmd.ToString("X") + ") : MC07_Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
        }
        //***********************************************************************************************************
        //
        //   The processing that the SlowStop button was clicked.
        //
        //***********************************************************************************************************
        private void button_SlowStop_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;

            //*** SLOW STOP COMMAND ***
            Cmd = 0xFE;
            if (MC07.BWDriveCommand(hDev, ref Cmd, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07_BWDriveCommand(H'" + Cmd.ToString("X") + ") : MC07_Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }
        }

        //***********************************************************************************************************
        //
        //   The processing that the DataSet button was clicked.
        //
        //***********************************************************************************************************
        private void button_DataSet_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;
            uint LData = 0;

            label_Message.Text = "";

            //*** FSPD SET COMMAND       : 5000Hz ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x5;
            LData = 5000;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }

            //*** JSPD SET COMMAND       : 1000Hz ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0xC;
            LData = 1000;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }

            //*** HIGH SPEED SET COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x6;
            LData = 5000 | (0x3 << 16);     // HSPD       : 5000Hz
            // RESOL No.  : 3;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** LOW SPEED SET COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x7;
            LData = 1000 | (1000 << 16);     // LSPD       : 1000Hz
            // ELSPD      : 1000Hz
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** RATE SET COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x8;
            LData = 200 | (200 << 16);     // UCYCLE     : 100μs
            // DCYCLE     : 100μs
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** ORIGIN SPEC SET ***
            if (CheckStatus1(hDev) == false) return;
            if (MC07.SetOrgSpec(hDev, 0x8000, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.SetOrgSpec() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }

            //*** MARGIN PULSE            : 5 Pulse ***
            if (CheckStatus1(hDev) == false) return;
            if (MC07.SetOrgMarginPulse(hDev, 5, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.SetOrgMarginPulse() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }


            label_Message.Text = "DATA SET Succeed";

        }

        //***********************************************************************************************************
        //
        //   The processing that the -Scan button was clicked.
        //
        //***********************************************************************************************************
        private void button_Ccw_Scan_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;
            byte StopCode = 0;

            label_Message.Text = "";
            //*** -CCW SCAN DRIVE COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x13;
            if (MC07.BWDriveCommand(hDev, ref Cmd, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.BWDriveCommand(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the +Scan button was clicked.
        //
        //***********************************************************************************************************
        private void button_Cw_Scan_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;
            byte StopCode = 0;

            label_Message.Text = "";
            //*** +CW SCAN DRIVE COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x12;
            if (MC07.BWDriveCommand(hDev, ref Cmd, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.BWDriveCommand(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the Org button was clicked.
        //
        //***********************************************************************************************************
        private void button_Org_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            byte StopCode = 0;

            label_Message.Text = "";
            //*** ORIGIN DRIVE ***
            if (CheckStatus1(hDev) == false) return;
            if (MC07.Org(hDev, MC07.MC07_ORG3, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.Org() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, true);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the Return button was clicked.
        //
        //***********************************************************************************************************
        private void button_Rtn_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            byte StopCode = 0;
            ushort Cmd = 0;
            uint LData = 0;

            label_Message.Text = "";
            //*** ABSOLUTE INDEX DRIVE COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x15;
            LData = 0;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the -Index button was clicked.
        //
        //***********************************************************************************************************
        private void button_Ccw_Index_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            byte StopCode = 0;
            ushort Cmd = 0;
            uint LData = 0;

            label_Message.Text = "";
            //*** INCREMENTAL INDEX DRIVE COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x14;
            LData = MC07.Unsigned32(-3000);
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the +Index button was clicked.
        //
        //***********************************************************************************************************
        private void button_Cw_Index_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            byte StopCode = 0;
            ushort Cmd = 0;
            uint LData = 0;

            label_Message.Text = "";
            //*** INCREMENTAL INDEX DRIVE COMMAND ***
            if (CheckStatus1(hDev) == false) return;
            Cmd = 0x14;
            LData = 3000;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            button_Disable();
            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();
        }

        //***********************************************************************************************************
        //
        //   The processing that the Demo button was clicked.
        //
        //***********************************************************************************************************
        private void button_Demo_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort n;
            byte StopCode = 0;
            uint LData;
            ushort Cmd;

            label_Message.Text = "";
            button_Disable();

            if (CheckStatus1(hDev) == false)
            {
                button_Enable();
                return;
            }
            //*** ORIGIN DRIVE ***
            if (MC07.Org(hDev, MC07.MC07_ORG3, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.Org() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                button_Enable();
                return;
            }
            Ready_Wait(hDev, ref StopCode, true);
            if (StopCode != 0)
            {
                Stop_Display(StopCode);
                button_Enable();
                return;
            }

            //*** ADDRESS COUNTER PRESET ***
            Cmd = 0x80;
            LData = 0;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                button_Enable();
                return;
            }

            //*** INCREMENTAL INDEX DRIVE 4 Times ***
            for (n = 0; n < 4; n++)
            {
                if (CheckStatus1(hDev) == false)
                {
                    button_Enable();
                    return;
                }

                Cmd = 0x14;
                LData = 4000;
                if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
                {
                    label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                    button_Enable();
                    return;
                }

                Ready_Wait(hDev, ref StopCode, false);
                if (StopCode != 0)
                {
                    Stop_Display(StopCode);
                    button_Enable();
                    return;
                }
            }

            //*** ABSOLUTE INDEX DRIVE ***
            if (CheckStatus1(hDev) == false)
            {
                button_Enable();
                return;
            }

            Cmd = 0x15;
            LData = 30000;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                button_Enable();
                return;
            }

            Ready_Wait(hDev, ref StopCode, false);
            if (StopCode != 0)
            {
                Stop_Display(StopCode);
                button_Enable();
                return;
            }

            //*** ABSOLUTE INDEX DRIVE ***
            if (CheckStatus1(hDev) == false)
            {
                button_Enable();
                return;
            }

            Cmd = 0x15;
            LData = 0;
            if (MC07.LWDrive(hDev, Cmd, ref LData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                button_Enable();
                return;
            }

            Ready_Wait(hDev, ref StopCode, false);
            Stop_Display(StopCode);
            button_Enable();

        }

        //********************************************************************************************************************
        //
        //   The processing that the Clear Error button was clicked.;
        //
        //********************************************************************************************************************
        private void button_ClrError_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            if (MC07.ClrError(hDev, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.ClrError() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }

            label_Message.Text = "MC07.ClrError() succeed";
        }
        //***********************************************************************************************************
        //
        //   The processing that the Form was loaded.
        //
        //***********************************************************************************************************
        private void FormMplSample_Load(object sender, EventArgs e)
        {
            button_Open.Enabled = true;
            button_Close.Enabled = false;
            button_End.Enabled = true;
            button_Reset.Enabled = false;
            button_FastStop.Enabled = false;
            button_SlowStop.Enabled = false;
            button_DataSet.Enabled = false;
            button_Ccw_Scan.Enabled = false;
            button_Cw_Scan.Enabled = false;
            button_Org.Enabled = false;
            button_Rtn.Enabled = false;
            button_Ccw_Index.Enabled = false;
            button_Cw_Index.Enabled = false;
            button_Demo.Enabled = false;
            label_NowAddress.Text = "Please open the device.";

            label_Message_GenIO.Text = "Please open General-purpose IO.";
            button_OpenGenIO.Text = "Open \r\nGeneral-purpose IO";
            button_CloseGenIO.Text = "Close \r\nGeneral-purpose IO";

            button_OpenGenIO.Enabled = true;
            button_CloseGenIO.Enabled = false;
            button_ReadGenIn0.Enabled = false;
            button_GenOut0.Enabled = false;
            button_GenOut1.Enabled = false;
            button_GenOut2.Enabled = false;
            button_GenOut3.Enabled = false;

        }

        //***********************************************************************************************************
        //
        //   The processing that the Form was Closed.
        //
        //***********************************************************************************************************
        private void FormMplSample_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            Boolean Ret = false;

            Ret = MC07.BClose(hDev, ref sResult);

            Ret = MC07.BPortClose(hInPort1, ref sResult);

            Ret = MC07.BPortClose(hOutPort1, ref sResult);

        }

        //***********************************************************************************************************
        //
        //   Action button Disable Procedure
        //
        //***********************************************************************************************************
        private void button_Disable()
        {
            button_Reset.Enabled = false;
            button_DataSet.Enabled = false;
            button_Ccw_Scan.Enabled = false;
            button_Cw_Scan.Enabled = false;
            button_Org.Enabled = false;
            button_Rtn.Enabled = false;
            button_Ccw_Index.Enabled = false;
            button_Cw_Index.Enabled = false;
            button_Demo.Enabled = false;
            button_Close.Enabled = false;
            button_ClrError.Enabled = false;
        }

        //***********************************************************************************************************
        //
        //   Action button Enable Procedure
        //
        //***********************************************************************************************************
        private void button_Enable()
        {
            button_Reset.Enabled = true;
            button_DataSet.Enabled = true;
            button_Ccw_Scan.Enabled = true;
            button_Cw_Scan.Enabled = true;
            button_Org.Enabled = true;
            button_Rtn.Enabled = true;
            button_Ccw_Index.Enabled = true;
            button_Cw_Index.Enabled = true;
            button_Demo.Enabled = true;
            button_Close.Enabled = true;
            button_ClrError.Enabled = true;
        }

        //***********************************************************************************************************
        //
        //   Waits until MCC07 becomes ready condition. Meantime position address of motor is displayed.
        //   Parameter hDevice         ･･･ Device Handle
        //             StopCode        ･･･ Pointer of the variable where the drive stoppage factor is stored.
        //                                 0:PASS  1:FSEND  2:SSEND  3:LSEND  4:SENSOR ERROR  5:ERROR PULSE ERROR  6:ADDRESS ERROR
        //                                 7:FUNCTION ERROR;
        //             OriginDriveFlag ･･･ The Flag is shown that ORIGIN DRIVE executing or other DRIVE executing.
        //                                 true:ORIGIN DRIVE executing  false:other DRIVE executing
        //
        //***********************************************************************************************************
        private void Ready_Wait(uint hDevice, ref byte StopCode, bool OriginDriveFlag)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Status1 = 0;

            do
            {
                Now_Address_Display(hDevice);
                Application.DoEvents();
                Now_Address_Display(hDevice);
                if (MC07.BRStatus1(hDevice, ref Status1, ref sResult) == false)
                {
                    label_Message.Text = "It failed in MC07.BRStatus1() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                    StopCode = 7;
                    return;
                }
            } while ((Status1 & 0x0001) != 0);

            Now_Address_Display(hDevice);

            if (OriginDriveFlag)
            {
                if (MC07.ReadOrgStatus(hDevice, ref Status1, ref sResult) == false)
                {
                    label_Message.Text = "It failed in MC07.ReadOrgStatus() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                    StopCode = 7;
                    return;
                }
                if ((Status1 & 0x8000) != 0)
                    StopCode = 6;                                            // ADDRESS ERROR
                else if ((Status1 & 0x4000) != 0)
                    StopCode = 5;                                            // ERROR PULSE ERROR
                else if ((Status1 & 0x2000) != 0)
                    StopCode = 4;                                            // SENSOR ERROR
                else if ((Status1 & 0x0020) != 0)
                    StopCode = 3;                                            // LSEND
                else if ((Status1 & 0x0040) != 0)
                    StopCode = 2;                                            // SSEND
                else if ((Status1 & 0x0080) != 0)
                    StopCode = 1;                                            // FSEND
                else
                    StopCode = 0;                                            // PASS
            }
            else
            {
                if ((Status1 & 0x0020) != 0)
                    StopCode = 3;                                            // LSEND
                else if ((Status1 & 0x0040) != 0)
                    StopCode = 2;                                            // SSEND
                else if ((Status1 & 0x0080) != 0)
                    StopCode = 1;                                            // FSEND
                else
                    StopCode = 0;                                            // PASS
            }
        }

        //***********************************************************************************************************
        //
        //   Position address of motor is displayed.
        //   Parameter hDevice ･･･ Device Handle
        //
        //***********************************************************************************************************
        private void Now_Address_Display(uint hDevice)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            uint WData = 0;
            uint RData = 0;
            ushort Cmd = 0;

            //*** ADDRESS COUNTER READ COMMAND ***
            Cmd = 0xD8;
            if (MC07.LWRDrive(hDevice, Cmd, ref WData, ref RData, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.LWRDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return;
            }
            // Position address is displayed.
            label_NowAddress.Text = string.Format("{0:#,###,###,##0}", MC07.Signed32(RData));
        }

        //***********************************************************************************************************
        //
        //   The stoppage factor of drive is displayed.
        //   Parameters StopCode ･･･ The variable where the drive stoppage factor is stored.
        //                           0:PASS  1:FSEND  2:SSEND  3:LSEND  4:SENSOR ERROR  5:ERROR PULSE ERROR  6:ADDRESS ERROR
        //                           7:FUNCTION ERROR(NO MESSAGE);
        //***********************************************************************************************************
        private void Stop_Display(byte StopCode)
        {
            switch (StopCode)
            {
                case 1:
                    label_Message.Text = "FSSTOP was input.";
                    break;

                case 2:
                    label_Message.Text = "SLSTOP was input.";
                    break;

                case 3:
                    label_Message.Text = "LIMIT was input.";
                    break;

                case 4:
                    label_Message.Text = "SENSOR ERROR was detected.\r\n Please click 'Clear Error'"; ;
                    break;

                case 5:
                    label_Message.Text = "ERROR PULSE ERROR was detected.\r\n Please click 'Clear Error'"; ;
                    break;

                case 6:
                    label_Message.Text = "ADDRESS ERROR was detected.\r\n Please click 'Clear Error'";
                    break;

                case 7:
                    break;

                default:
                    label_Message.Text = "Drive ended.";
                    break;
            }
        }

        //********************************************************************************************************************
        //
        //   Check Status1 PORT.;
        //   Parameter hDevice         ･･･ Device Handle;
        //   Return Value              ･･･ TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0;
        //                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1;
        //********************************************************************************************************************
        private Boolean CheckStatus1(uint hDevice)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Cmd = 0;
            ushort Status1 = 0;
            uint WData = 0;
            uint RData = 0;

            //*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
            if (MC07.BWaitDriveCommand(hDevice, 1000, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.BWaitDriveCommand() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return false;
            }

            //*** READ STATUS1 ***
            if (MC07.BRStatus1(hDevice, ref Status1, ref sResult) == false)
            {
                label_Message.Text = "It failed in MC07.BRStatus1() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                return false;
            }

            //*** CHECK STATUS1 ERROR BIT = 0 ***
            if ((Status1 & 0x0010) != 0)
            {
                //*** READ ERROR STATUS ***
                Cmd = 0xD1;
                if (MC07.LWRDrive(hDevice, Cmd, ref WData, ref RData, ref sResult) == false)
                {
                    label_Message.Text = "It failed in MC07.LWRDrive(H'" + Cmd.ToString("X") + ") : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                    return false;
                }

                //GET DRIVE DATA1 PORT
                RData = RData & 0xFFFF;

                label_Message.Text = "STATUS1 ERROR = 1 : ERROR STATUS = H'" + RData.ToString("X") + System.Environment.NewLine + "  Plese click 'Clear Error'";

                return false;

            }

            return true;

        }



        //********************************************************************************************************************
        //
        //   The processing that the Open General-purpose IO was clicked.;
        //
        //********************************************************************************************************************
        private void button_OpenGenIO_Click_1(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;
            Boolean Ret = false;

            label_Message_GenIO.Text = "";

            //*** BPORT OPEN ***
            if (MC07.BPortOpen(0, MC07.MC07_IO_IN_PORT1, ref hInPort1, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOpen() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** BPORT OPEN ***
            if (MC07.BPortOpen(0, MC07.MC07_IO_OUT_PORT1, ref hOutPort1, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOpen() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                //Because it is avoided double BPort Open Error 
                Ret = MC07.BPortClose(hInPort1, ref sResult);
                return;
            }
            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();

                //Because it is avoided double BPort Open Error 
                Ret = MC07.BPortClose(hInPort1, ref sResult);
                Ret = MC07.BPortClose(hOutPort1, ref sResult);
                return;
            }

            if ((Data & 0x1) != 0) label_GenOut0.Text = "ON"; else label_GenOut0.Text = "OFF";

            if ((Data & 0x2) != 0) label_GenOut1.Text = "ON"; else label_GenOut1.Text = "OFF";

            if ((Data & 0x4) != 0) label_GenOut2.Text = "ON"; else label_GenOut2.Text = "OFF";

            if ((Data & 0x8) != 0) label_GenOut3.Text = "ON"; else label_GenOut3.Text = "OFF";

            //*** READ BPORT IN ***//
            button_ReadGenIn0.Enabled = true;
            button_ReadGenIn0.PerformClick();

            button_OpenGenIO.Enabled = false;
            button_CloseGenIO.Enabled = true;
            button_GenOut0.Enabled = true;
            button_GenOut1.Enabled = true;
            button_GenOut2.Enabled = true;
            button_GenOut3.Enabled = true;

        }

        //********************************************************************************************************************
        //
        //   The processing that the Close General-purpose IO was clicked.;
        //
        //********************************************************************************************************************
        private void button_CloseGenIO_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);

            //*** BPORT CLOSE ***
            if (MC07.BPortClose(hInPort1, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortClose() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** BPORT CLOSE ***
            if (MC07.BPortClose(hOutPort1, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortClose() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            label_Message_GenIO.Text = "";
            label_GenOut0.Text = ""; label_GenOut1.Text = ""; label_GenOut2.Text = ""; label_GenOut3.Text = "";
            label_GenIn0.Text = ""; label_GenIn1.Text = ""; label_GenIn2.Text = ""; label_GenIn3.Text = "";

            button_OpenGenIO.Enabled = true;
            button_CloseGenIO.Enabled = false;
            button_ReadGenIn0.Enabled = false;
            button_GenOut0.Enabled = false;
            button_GenOut1.Enabled = false;
            button_GenOut2.Enabled = false;
            button_GenOut3.Enabled = false;

        }

        //********************************************************************************************************************
        //
        //   The processing that General-purpose I/O OUT00 was clicked.;
        //
        //********************************************************************************************************************
        private void button_GenOut0_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;

            label_Message_GenIO.Text = "";

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x1) != 0)
            {
                //ON -> OFF
                Data = (ushort)(Data & 0xE);
            }
            else
            {
                //OFF -> ON
                Data = (ushort)(Data | 0x1);
            }

            //*** BPORT OUT ***
            if (MC07.BPortOut(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOut() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x1) != 0) label_GenOut0.Text = "ON"; else label_GenOut0.Text = "OFF";

        }

        //********************************************************************************************************************
        //
        //   The processing that General-purpose I/O OUT01 was clicked.;
        //
        //********************************************************************************************************************
        private void button_GenOut1_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;

            label_Message_GenIO.Text = "";

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x2) != 0)
            {
                //ON -> OFF
                Data = (ushort)(Data & 0xD);
            }
            else
            {
                //OFF -> ON
                Data = (ushort)(Data | 0x2);
            }

            //*** BPORT OUT ***
            if (MC07.BPortOut(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOut() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x2) != 0) label_GenOut1.Text = "ON"; else label_GenOut1.Text = "OFF";

        }

        //********************************************************************************************************************
        //
        //   The processing that General-purpose I/O OUT02 was clicked.;
        //
        //********************************************************************************************************************
        private void button_GenOut2_Click(object sender, EventArgs e)
        {
             MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;

            label_Message_GenIO.Text = "";

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x4) != 0)
            {
                //ON -> OFF
                Data = (ushort)(Data & 0xB);
            }
            else
            {
                //OFF -> ON
                Data = (ushort)(Data | 0x4);
            }

            //*** BPORT OUT ***
            if (MC07.BPortOut(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOut() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x4) != 0) label_GenOut2.Text = "ON"; else label_GenOut2.Text = "OFF";


        }

        //********************************************************************************************************************
        //
        //   The processing that General-purpose I/O OUT03 was clicked.;
        //
        //********************************************************************************************************************
        private void button_GenOut3_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;

            label_Message_GenIO.Text = "";

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x8) != 0)
            {
                //ON -> OFF
                Data = (ushort)(Data & 0x7);
            }
            else
            {
                //OFF -> ON
                Data = (ushort)(Data | 0x8);
            }

            //*** BPORT OUT ***
            if (MC07.BPortOut(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortOut() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            //*** READ BPORT OUT ***
            if (MC07.BPortIn(hOutPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x8) != 0) label_GenOut3.Text = "ON"; else label_GenOut3.Text = "OFF";

        }

        //********************************************************************************************************************
        //
        //   The processing that the Read General-purpose I/O was clicked.;
        //
        //********************************************************************************************************************
        private void button_ReadGenIn0_Click(object sender, EventArgs e)
        {
            MC07_S_RESULT sResult = new MC07_S_RESULT(0);
            ushort Data = 0;

            label_Message_GenIO.Text = "";

            //*** READ BPORT IN ***
            if (MC07.BPortIn(hInPort1, ref Data, ref sResult) == false)
            {
                label_Message_GenIO.Text = "It failed in MC07.BPortIn() : MC07.Result(1)=" + sResult.MC07_Result[1].ToString();
                return;
            }

            if ((Data & 0x1) != 0) label_GenIn0.Text = "ON"; else label_GenIn0.Text = "OFF";

            if ((Data & 0x2) != 0) label_GenIn1.Text = "ON"; else label_GenIn1.Text = "OFF";

            if ((Data & 0x4) != 0) label_GenIn2.Text = "ON"; else label_GenIn2.Text = "OFF";

            if ((Data & 0x8) != 0) label_GenIn3.Text = "ON"; else label_GenIn3.Text = "OFF";

        }



    }
}
