Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Module Mc07A
    '**********************************************************************************************
    '
    '   definitions, types, function for Visual Basic.NET       5.3101.12.2206
    '
    '**********************************************************************************************

    '*** CallBack Function Delegate Declarations ***
    Public Delegate Sub PLPMC07CALLBACK(ByVal Status As Integer, ByVal UserData As Integer)

    '*** RESULT STRUCTURE ***
    Structure MC07_S_RESULT
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Result() As Short
        Public Sub Initialize()
            ReDim MC07_Result(4)
        End Sub
    End Structure

    '*** DATA STRUCTURE ***
    Structure MC07_S_DATA
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Data() As Short
        Public Sub Initialize()
            ReDim MC07_Data(4)
        End Sub
    End Structure

    '*** XY POSITION STRUCTURE ***
    Structure MC07_S_XY_POSITION
        Public X As Integer
        Public Y As Integer
    End Structure

    '*** SPEED SETUP STRUCTURE ***
    Structure MC07_S_SPEED_RATE
        Public FSpd As Integer
        Public HighSpeed As Integer
        Public LowSpeed As Integer
        Public EndLowSpeed As Integer
        Public SUArea As Integer
        Public SDArea As Integer
        Public URateNo As Integer
        Public DRateNo As Integer
    End Structure

    '*** ORG PARAMETER STRUCTURE ***
    Structure MC07_S_ORG_PARAM
        Public Spec As Integer
        Public MarginPulse As Integer
        Public LimitDelay As Integer
        Public ScanDelay As Integer
        Public PulseDelay As Integer
        Public CScanErrorPulse As Integer
        Public PulseErrorPulse As Integer
        Public OffsetPulse As Integer
        Public PresetPulse As Integer
    End Structure

    '*** DEFINITION ***
    Public Const MC07_X As Short = 0
    Public Const MC07_Y As Short = 1
    Public Const MC07_Z As Short = 2
    Public Const MC07_A As Short = 3
    Public Const MC07_B As Short = 4
    Public Const MC07_C As Short = 5

    Public Const MC07_X1 As Short = 0
    Public Const MC07_Y1 As Short = 1
    Public Const MC07_Z1 As Short = 2
    Public Const MC07_A1 As Short = 3
    Public Const MC07_B1 As Short = 4
    Public Const MC07_C1 As Short = 5
    Public Const MC07_X2 As Short = 6
    Public Const MC07_Y2 As Short = 7
    Public Const MC07_Z2 As Short = 8
    Public Const MC07_A2 As Short = 9
    Public Const MC07_B2 As Short = 10
    Public Const MC07_C2 As Short = 11

    Public Const MC07_ORG0 As Short = 0
    Public Const MC07_ORG1 As Short = 1
    Public Const MC07_ORG2 As Short = 2
    Public Const MC07_ORG3 As Short = 3
    Public Const MC07_ORG4 As Short = 4
    Public Const MC07_ORG5 As Short = 5
    Public Const MC07_ORG10 As Short = 10
    Public Const MC07_ORG11 As Short = 11
    Public Const MC07_ORG12 As Short = 12

    Public Const MC07_INT_FACTOR_RDYINT As Short = &H1S
    Public Const MC07_INT_FACTOR_STBY As Short = &H2S
    Public Const MC07_INT_FACTOR_COMREG_EP As Short = &H4S
    Public Const MC07_INT_FACTOR_nCOMREG_FL As Short = &H8S
    Public Const MC07_INT_FACTOR_MAN As Short = &H10S
    Public Const MC07_INT_FACTOR_DALM As Short = &H20S
    Public Const MC07_INT_FACTOR_SS0 As Short = &H40S
    Public Const MC07_INT_FACTOR_SS1 As Short = &H80S
    Public Const MC07_INT_FACTOR_ADRINT As Short = &H100S
    Public Const MC07_INT_FACTOR_CNTINT As Short = &H200S
    Public Const MC07_INT_FACTOR_DFLINT As Short = &H400S
    Public Const MC07_INT_FACTOR_ERRINT As Short = &H800S
    Public Const MC07_INT_FACTOR_OUT2 As Short = &H1000S
    Public Const MC07_INT_FACTOR_OUT3 As Short = &H2000S
    Public Const MC07_INT_FACTOR_GPIO0 As Short = &H4000S
    Public Const MC07_INT_FACTOR_GPIO1 As Short = &H8000S

    Public Const MC07_CCW As Short = 0
    Public Const MC07_CW As Short = 1

    Public Const MC07_IO_IN_PORT1 As Short = &H0S
    Public Const MC07_IO_IN_PORT2 As Short = &H1S
    Public Const MC07_IO_OUT_PORT1 As Short = &H100S
    Public Const MC07_IO_OUT_PORT2 As Short = &H101S

    '*** MPL Function Declarations ***
    Declare Function MC07_Reset Lib "Mc07A.dll" (ByVal BoardNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadBoardType Lib "Mc07A.dll" (ByVal BoardNo As Short, ByRef pBoardType As Short, ByRef pVersion As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BOpen Lib "Mc07A.dll" (ByVal BoardNo As Short, ByVal Axis As Short, ByRef phDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BClose Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ClrError Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWDrive Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWData Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWDrive Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWData Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveCommand Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pCmd As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData1 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData2 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus1 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus2 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus3 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus4 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus5 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LRDrive Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IRDrive Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData1 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData2 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWRDrive Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pWriteData As Integer, ByRef pReadData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitDriveCommand Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitComregNotFull Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BIsWait Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pWaitSts As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BBreakWait Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetSpeedRate Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal ResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadSpeedRate Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncStrCp Lib "Mc07A.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncCirCp Lib "Mc07A.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirShortPulse Lib "Mc07A.dll" (ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pShortPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirCenterPosition Lib "Mc07A.dll" (ByRef psPassPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pDir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IncFromAbs Lib "Mc07A.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByRef psAbsPosition As MC07_S_XY_POSITION, ByRef psIncPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgSpec Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal Spec As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgMarginPulse Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal MarginPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgDelay Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal LimitDelay As Short, ByVal ScanDelay As Short, ByVal PulseDelay As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgErrorPulse Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal CScanErrorPulse As Integer, ByVal PulseErrorPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgOffsetPulse Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal OffsetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgPresetPulse Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal PresetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgParam Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psOrgParam As MC07_S_ORG_PARAM, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ResetOrgFlag Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_Org Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal OrgType As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_OpenDevInt Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_CloseDevInt Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetIntCallBack Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal IntFactor As Integer, ByVal Func As PLPMC07CALLBACK, ByVal UserData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetIntEvent Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal IntFactor As Integer, ByVal hEvent As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadIntStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal IntFactor As Integer, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ClearIntSet Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWHardConfig Lib "Mc07A.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWHardConfigCommand Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pCmd As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWHardConfigData1 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWHardConfigData2 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWHardConfigData3 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigPauseStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigStbyStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigSigStatus Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigData1 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigData2 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRHardConfigData3 Lib "Mc07A.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Sub MC07_SetData Lib "Mc07A.dll" (ByVal Data As Integer, ByRef psData As MC07_S_DATA)
    Declare Function MC07_GetData Lib "Mc07A.dll" (ByRef psData As MC07_S_DATA) As Integer
    Declare Function MC07_BPortOpen Lib "Mc07A.dll" (ByVal BoardNo As Short, ByVal IoPort As Short, ByRef phPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortClose Lib "Mc07A.dll" (ByVal hPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortOut Lib "Mc07A.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortIn Lib "Mc07A.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_Unsigned16 Lib "Mc07A.dll" (ByVal Data As Short) As UShort
    Declare Function MC07_Signed16 Lib "Mc07A.dll" (ByVal Data As UShort) As Short
    Declare Function MC07_Unsigned32 Lib "Mc07A.dll" (ByVal Data As Integer) As UInteger
    Declare Function MC07_Signed32 Lib "Mc07A.dll" (ByVal Data As UInteger) As Integer
End Module
